searchNodes=[{"doc":"BrazeEx is an automatically generated http api wrapper for integrating with the Braze HTTP API. See BrazeEx.Connection for configuration details","ref":"BrazeEx.html","title":"BrazeEx","type":"module"},{"doc":"API calls for all endpoints tagged CatalogsCatalogItemsAsynchronous .","ref":"BrazeEx.Api.CatalogsCatalogItemsAsynchronous.html","title":"BrazeEx.Api.CatalogsCatalogItemsAsynchronous","type":"module"},{"doc":"Delete Multiple Catalog Items Use this endpoint to delete multiple items in your catalog. Each request can support up to 50 items. This endpoint is asynchronous. Rate limit This endpoint has a shared rate limit of 100 requests per minute between all asynchronous catalog item endpoints. Path parameters Parameter Required Data Type Description catalog_name Required String Name of the catalog. Request parameters Parameter Required Data Type Description items Required Array An array that contains item objects. The item objects should contain an id referencing the items Braze should delete. Up to 50 item objects are allowed per request. Example request curl -- location -- request DELETE &#39;https://rest.iad-03.braze.com/catalogs/restaurants/items&#39; -- header &#39;Content-Type: application/json&#39; -- header &#39;Authorization: Bearer YOUR-REST-API-KEY&#39; -- data - raw &#39;{ &quot;items&quot;: [ {&quot;id&quot;: &quot;restaurant1&quot;}, {&quot;id&quot;: &quot;restaurant2&quot;}, {&quot;id&quot;: &quot;restaurant3&quot;} ] }&#39; Response There are three status code responses for this endpoint: 202 , 400 , and 404 . Example success response The status code 202 could return the following response body. { &quot;message&quot;: &quot;success&quot; } Example error response The status code 400 could return the following response body. Refer to Troubleshooting for more information about errors you may encounter. { &quot;errors&quot;: [ { &quot;id&quot;: &quot;items-missing-ids&quot;, &quot;message&quot;: &quot;There are 1 item(s) that do not have ids&quot;, &quot;parameters&quot;: [], &quot;parameter_values&quot;: [] } ], &quot;message&quot;: &quot;Invalid Request&quot;, } Troubleshooting The following table lists possible returned errors and their associated troubleshooting steps. Error Troubleshooting catalog-not-found Check that the catalog name is valid. request-includes-too-many-items Your request has too many items. The item limit per request is 50. invalid-ids Item IDs can only include letters, numbers, hyphens, and underscores. ids-too-large Item IDs can't be more than 250 characters. ids-not-unique Check that the item IDs are unique in the request. ids-not-strings Item IDs must be of type string. items-missing-ids There are items that do not have item IDs. Check that each item has an item ID. Parameters connection (BrazeEx.Connection): Connection to server catalog_name (String.t): opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.CatalogsCatalogItemsAsynchronous.html#catalogs_catalog_name_items_delete/3","title":"BrazeEx.Api.CatalogsCatalogItemsAsynchronous.catalogs_catalog_name_items_delete/3","type":"function"},{"doc":"Edit Multiple Catalog Items Use this endpoint to edit multiple items in your catalog. Each request can support up to 50 items. This endpoint is asynchronous. Rate limit This endpoint has a shared rate limit of 100 requests per minute between all asynchronous catalog item endpoints. Path parameters Parameter Required Data Type Description catalog_name Required String Name of the catalog. Request parameters Parameter Required Data Type Description items Required Array An array that contains item objects. The item objects should contain fields that exist in the catalog. Up to 50 item objects are allowed per request. Example request curl -- location -- request PATCH &#39;https://rest.iad-03.braze.com/catalogs/restaurants/items&#39; -- header &#39;Content-Type: application/json&#39; -- header &#39;Authorization: Bearer YOUR-REST-API-KEY&#39; -- data - raw &#39;{ &quot;items&quot;: [ { &quot;id&quot;: &quot;restaurant1&quot;, &quot;Name&quot;: &quot;Restaurant&quot;, &quot;Loyalty_Program&quot;: false, &quot;Open_Time&quot;: &quot;2021-09-03T09:03:19.967+00:00&quot; }, { &quot;id&quot;: &quot;restaurant3&quot;, &quot;City&quot;: &quot;San Francisco&quot;, &quot;Rating&quot;: 2 } ] }&#39; Response There are three status code responses for this endpoint: 202 , 400 , and 404 . Example success response The status code 202 could return the following response body. { &quot;message&quot;: &quot;success&quot; } Example error response The status code 400 could return the following response body. Refer to Troubleshooting for more information about errors you may encounter. { &quot;errors&quot;: [ { &quot;id&quot;: &quot;invalid-fields&quot;, &quot;message&quot;: &quot;Some of the fields given do not exist in the catalog&quot;, &quot;parameters&quot;: [ &quot;id&quot; ], &quot;parameter_values&quot;: [ &quot;restaurant1&quot; ] } ], &quot;message&quot;: &quot;Invalid Request&quot; } Troubleshooting The following table lists possible returned errors and their associated troubleshooting steps. Error Troubleshooting catalog-not-found Check that the catalog name is valid. item-array-invalid items must be an array of objects. request-includes-too-many-items Your request has too many items. The item limit per request is 50. invalid-ids Item IDs can only include letters, numbers, hyphens, and underscores. ids-too-large Item IDs can't be more than 250 characters. ids-not-unique Item IDs must be unique in the request. ids-not-strings Item IDs must be of type string. items-missing-ids There are items that do not have item IDs. Check that each item has an item ID. items-too-large Item values can't exceed 5,000 characters. invalid-fields Confirm that the fields in the request exist in the catalog. unable-to-coerce-value Item types can't be converted. Parameters connection (BrazeEx.Connection): Connection to server catalog_name (String.t): opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.CatalogsCatalogItemsAsynchronous.html#catalogs_catalog_name_items_patch/3","title":"BrazeEx.Api.CatalogsCatalogItemsAsynchronous.catalogs_catalog_name_items_patch/3","type":"function"},{"doc":"Create Multiple Catalog Items Use this endpoint to create multiple items in your catalog. Each request can support up to 50 items. This endpoint is asynchronous. Rate limit This endpoint has a shared rate limit of 100 requests per minute between all asynchronous catalog item endpoints. Path parameters Parameter Required Data Type Description catalog_name Required String Name of the catalog. Request parameters Parameter Required Data Type Description items Required Array An array that contains item objects. The item objects should contain all of the fields in the catalog. Up to 50 item objects are allowed per request. Example Request curl -- location -- request POST &#39;https://rest.iad-03.braze.com/catalogs/restaurants/items&#39; -- header &#39;Content-Type: application/json&#39; -- header &#39;Authorization: Bearer YOUR-REST-API-KEY&#39; -- data - raw &#39;{ &quot;items&quot;: [ { &quot;id&quot;: &quot;restaurant1&quot;, &quot;Name&quot;: &quot;Restaurant1&quot;, &quot;City&quot;: &quot;New York&quot;, &quot;Cuisine&quot;: &quot;American&quot;, &quot;Rating&quot;: 5, &quot;Loyalty_Program&quot;: true, &quot;Created_At&quot;: &quot;2022-11-01T09:03:19.967+00:00&quot; }, { &quot;id&quot;: &quot;restaurant2&quot;, &quot;Name&quot;: &quot;Restaurant2&quot;, &quot;City&quot;: &quot;New York&quot;, &quot;Cuisine&quot;: &quot;American&quot;, &quot;Rating&quot;: 10, &quot;Loyalty_Program&quot;: true, &quot;Created_At&quot;: &quot;2022-11-02T09:03:19.967+00:00&quot; }, { &quot;id&quot;: &quot;restaurant3&quot;, &quot;Name&quot;: &quot;Restaurant3&quot;, &quot;City&quot;: &quot;New York&quot;, &quot;Cuisine&quot;: &quot;American&quot;, &quot;Rating&quot;: 3, &quot;Loyalty_Program&quot;: false, &quot;Created_At&quot;: &quot;2022-11-03T09:03:19.967+00:00&quot; } ] }&#39; Response There are three status code responses for this endpoint: 202 , 400 , and 404 . Example success response The status code 202 could return the following response body. { &quot;message&quot;: &quot;success&quot; } Example error response The status code 400 could return the following response body. Refer to Troubleshooting for more information about errors you may encounter. { &quot;errors&quot;: [ { &quot;id&quot;: &quot;fields-do-not-match&quot;, &quot;message&quot;: &quot;Fields do not match with fields on the catalog&quot;, &quot;parameters&quot;: [ &quot;id&quot; ], &quot;parameter_values&quot;: [ &quot;restaurant2&quot; ] } ], &quot;message&quot;: &quot;Invalid Request&quot; } Troubleshooting The following table lists possible returned errors and their associated troubleshooting steps. Error Troubleshooting catalog-not-found Check that the catalog name is valid. item-array-invalid items must be an array of objects. request-includes-too-many-items Your request has too many items. The item limit per request is 50. invalid-ids Item IDs can only include letters, numbers, hyphens, and underscores. ids-too-large Item IDs can't be more than 250 characters. ids-not-unique Item IDs must be unique in the request. ids-not-strings Item IDs must be of type string. items-missing-ids There are items that do not have item IDs. Check that each item has an item ID. items-too-large Item values can't exceed 5,000 characters. invalid-fields Confirm that the fields in the request exist in the catalog. fields-do-not-match Updated fields must match the fields in the catalog. unable-to-coerce-value Item types can't be converted. Parameters connection (BrazeEx.Connection): Connection to server catalog_name (String.t): opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.CatalogsCatalogItemsAsynchronous.html#catalogs_catalog_name_items_post/3","title":"BrazeEx.Api.CatalogsCatalogItemsAsynchronous.catalogs_catalog_name_items_post/3","type":"function"},{"doc":"API calls for all endpoints tagged CatalogsCatalogItemsSynchronous .","ref":"BrazeEx.Api.CatalogsCatalogItemsSynchronous.html","title":"BrazeEx.Api.CatalogsCatalogItemsSynchronous","type":"module"},{"doc":"List Multiple Catalog Item Details Use this endpoint to return multiple catalog items and their content. Rate limit This endpoint has a shared rate limit of 50 requests per minute between all synchronous catalog item endpoints. Path parameters Parameter Required Data Type Description catalog_name Required String Name of the catalog. Query parameters Note that each call to this endpoint will return 50 items. For a catalog with more than 50 items, use the Link header to retrieve the data on the next page as shown in the following example response. Parameter Required Data Type Description cursor Optional String Determines the pagination of the catalog items. Request parameters There is no request body for this endpoint. Example requests Without cursor curl -- location -- request GET &#39;https://rest.iad-03.braze.com/catalogs/restaurants/items&#39; -- header &#39;Content-Type: application/json&#39; -- header &#39;Authorization: Bearer YOUR-REST-API-KEY&#39; With cursor curl -- location -- request GET &#39;https://rest.iad-03.braze.com/catalogs/restaurants/items?cursor=c2tpcDow&#39; -- header &#39;Content-Type: application/json&#39; -- header &#39;Authorization: Bearer YOUR-REST-API-KEY&#39; Response There are three status code responses for this endpoint: 200 , 400 , and 404 . Example success response The status code 200 could return the following response header and body. {% alert note %} The Link header won't exist if the catalog has less than or equal to 50 items. For calls without a cursor, prev will not show. When looking at the last page of items, next will not show. {% endalert %} Link : ; rel = &quot;prev&quot; , ; rel = &quot;next&quot; { &quot;items&quot;: [ { &quot;id&quot;: &quot;restaurant1&quot;, &quot;Name&quot;: &quot;Restaurant1&quot;, &quot;City&quot;: &quot;New York&quot;, &quot;Cuisine&quot;: &quot;American&quot;, &quot;Rating&quot;: 5, &quot;Loyalty_Program&quot;: true, &quot;Open_Time&quot;: &quot;2022-11-02T09:03:19.967Z&quot; }, { &quot;id&quot;: &quot;restaurant2&quot;, &quot;Name&quot;: &quot;Restaurant2&quot;, &quot;City&quot;: &quot;New York&quot;, &quot;Cuisine&quot;: &quot;American&quot;, &quot;Rating&quot;: 10, &quot;Loyalty_Program&quot;: true, &quot;Open_Time&quot;: &quot;2022-11-02T09:03:19.967Z&quot; }, { &quot;id&quot;: &quot;restaurant3&quot;, &quot;Name&quot;: &quot;Restaurant3&quot;, &quot;City&quot;: &quot;New York&quot;, &quot;Cuisine&quot;: &quot;American&quot;, &quot;Rating&quot;: 5, &quot;Loyalty_Program&quot;: false, &quot;Open_Time&quot;: &quot;2022-11-02T09:03:19.967Z&quot; } ], &quot;message&quot;: &quot;success&quot; } Example error response The status code 400 could return the following response body. Refer to Troubleshooting for more information about errors you may encounter. { &quot;errors&quot;: [ { &quot;id&quot;: &quot;invalid-cursor&quot;, &quot;message&quot;: &quot;'cursor' is not valid&quot;, &quot;parameters&quot;: [ &quot;cursor&quot; ], &quot;parameter_values&quot;: [ &quot;bad-cursor&quot; ] } ], &quot;message&quot;: &quot;Invalid Request&quot; } Troubleshooting The following table lists possible returned errors and their associated troubleshooting steps. Error Troubleshooting invalid-cursor Check that your cursor is valid. catalog-not-found Check that the catalog name is valid. Parameters connection (BrazeEx.Connection): Connection to server catalog_name (String.t): opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.CatalogsCatalogItemsSynchronous.html#catalogs_catalog_name_items_get/3","title":"BrazeEx.Api.CatalogsCatalogItemsSynchronous.catalogs_catalog_name_items_get/3","type":"function"},{"doc":"Delete a Catalog Item Use this endpoint to delete an item in your catalog. Rate limit This endpoint has a shared rate limit of 50 requests per minute between all synchronous catalog item endpoints. Request parameters There is no request body for this endpoint. Path parameters Parameter Required Data Type Description catalog_name Required String Name of the catalog. item_id Required String The ID of the catalog item. Example request curl -- location -- request DELETE &#39;https://rest.iad-03.braze.com/catalogs/restaurants/items/restaurant1&#39; -- header &#39;Content-Type: application/json&#39; -- header &#39;Authorization: Bearer YOUR-REST-API-KEY&#39; Response There are three status code responses for this endpoint: 202 , 400 , and 404 . Example success response The status code 202 could return the following response body. { &quot;message&quot;: &quot;success&quot; } Example error response The status code 400 could return the following response body. Refer to Troubleshooting for more information about errors you may encounter. { &quot;errors&quot;: [ { &quot;id&quot;: &quot;item-not-found&quot;, &quot;message&quot;: &quot;Could not find item&quot;, &quot;parameters&quot;: [ &quot;item_id&quot; ], &quot;parameter_values&quot;: [ &quot;restaurant34&quot; ] } ], &quot;message&quot;: &quot;Invalid Request&quot; } Troubleshooting The following table lists possible returned errors and their associated troubleshooting steps. Error Troubleshooting catalog-not-found Check that the catalog name is valid. item-not-found Check that the item to be deleted exists in your catalog. arbitrary-error An arbitrary error occurred. Please try again or contact Support . Parameters connection (BrazeEx.Connection): Connection to server catalog_name (String.t): item_id (String.t): opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.CatalogsCatalogItemsSynchronous.html#catalogs_catalog_name_items_item_id_delete/4","title":"BrazeEx.Api.CatalogsCatalogItemsSynchronous.catalogs_catalog_name_items_item_id_delete/4","type":"function"},{"doc":"List Catalog Item Details Use this endpoint to return a catalog item and its content. Rate limit This endpoint has a shared rate limit of 50 requests per minute between all synchronous catalog item endpoints. Path parameters Parameter Required Data Type Description catalog_name Required String Name of the catalog. item_id Required String The ID of the catalog item. Request parameters There is no request body for this endpoint. Example request curl -- location -- request GET &#39;https://rest.iad-03.braze.com/catalogs/restaurants/items/restaurant1&#39; -- header &#39;Content-Type: application/json&#39; -- header &#39;Authorization: Bearer YOUR-REST-API-KEY&#39; Response There are two status code responses for this endpoint: 200 and 404 . Example success response The status code 200 could return the following response body. { &quot;items&quot;: [ { &quot;id&quot;: &quot;restaurant3&quot;, &quot;Name&quot;: &quot;Restaurant1&quot;, &quot;City&quot;: &quot;New York&quot;, &quot;Cuisine&quot;: &quot;American&quot;, &quot;Rating&quot;: 5, &quot;Loyalty_Program&quot;: true, &quot;Open_Time&quot;: &quot;2022-11-01T09:03:19.967Z&quot; } ], &quot;message&quot;: &quot;success&quot; } Example error response The status code 404 could return the following response. Refer to Troubleshooting for more information about errors you may encounter. { &quot;errors&quot;: [ { &quot;id&quot;: &quot;item-not-found&quot;, &quot;message&quot;: &quot;Could not find item&quot;, &quot;parameters&quot;: [ &quot;item_id&quot; ], &quot;parameter_values&quot;: [ &quot;restaurant34&quot; ] } ], &quot;message&quot;: &quot;Invalid Request&quot; } Troubleshooting The following table lists possible returned errors and their associated troubleshooting steps, if applicable. Error Troubleshooting catalog-not-found Check that the catalog name is valid. item-not-found Check that the item is in the catalog. Parameters connection (BrazeEx.Connection): Connection to server catalog_name (String.t): item_id (String.t): opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.CatalogsCatalogItemsSynchronous.html#catalogs_catalog_name_items_item_id_get/4","title":"BrazeEx.Api.CatalogsCatalogItemsSynchronous.catalogs_catalog_name_items_item_id_get/4","type":"function"},{"doc":"Edit Catalog Items Use this endpoint to edit an item in your catalog. Rate Limit This endpoint has a shared rate limit of 50 requests per minute between all synchronous catalog item endpoints. Path parameters Parameter Required Data Type Description catalog_name Required String Name of the catalog. item_id Required String The ID of the catalog item. Request parameters Parameter Required Data Type Description items Required Array An array that contains item objects. The item objects should contain fields that exist in the catalog except for the id field. Only one item object is allowed per request. Example request curl -- location -- request PATCH &#39;https://rest.iad-03.braze.com/catalogs/restaurants/items/restaurant1&#39; -- header &#39;Content-Type: application/json&#39; -- header &#39;Authorization: Bearer YOUR-REST-API-KEY&#39; -- data - raw &#39;{ &quot;items&quot;: [ { &quot;Name&quot;: &quot;Restaurant&quot;, &quot;Loyalty_Program&quot;: false, &quot;Open_Time&quot;: &quot;2021-09-03T09:03:19.967+00:00&quot; } ] }&#39; Response There are three status code responses for this endpoint: 200 , 400 , and 404 . Example success response The status code 200 could return the following response body. { &quot;message&quot;: &quot;success&quot; } Example error response The status code 400 could return the following response body. Refer to Troubleshooting for more information about errors you may encounter. { &quot;errors&quot;: [ { &quot;id&quot;: &quot;invalid-fields&quot;, &quot;message&quot;: &quot;Some of the fields given do not exist in the catalog&quot;, &quot;parameters&quot;: [ &quot;id&quot; ], &quot;parameter_values&quot;: [ &quot;restaurant1&quot; ] } ], &quot;message&quot;: &quot;Invalid Request&quot; } Troubleshooting The following table lists possible returned errors and their associated troubleshooting steps. Error Troubleshooting catalog-not-found Check that the catalog name is valid. item-not-found Check that the item is in the catalog. item-array-invalid items must be an array of objects. request-includes-too-many-items You can only edit one catalog item per request. id-in-body An item ID already exists in the catalog. invalid-ids Supported characters for item ID names are letters, numbers, hyphens, and underscores. ids-too-large Character limit for each item ID is 250 characters. items-too-large Character limit for each item is 5,000 characters. invalid-fields Confirm that the fields in the request exist in the catalog. unable-to-coerce-value Item types can't be converted. filtered-set-field-too-long The field value is being used in a filtered set that exceeds the character limit for an item. arbitrary-error An arbitrary error occurred. Please try again or contact Support . Parameters connection (BrazeEx.Connection): Connection to server catalog_name (String.t): item_id (String.t): opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.CatalogsCatalogItemsSynchronous.html#catalogs_catalog_name_items_item_id_patch/4","title":"BrazeEx.Api.CatalogsCatalogItemsSynchronous.catalogs_catalog_name_items_item_id_patch/4","type":"function"},{"doc":"Create Catalog Item Use this endpoint to create an item in your catalog. Rate limit This endpoint has a shared rate limit of 50 requests per minute between all synchronous catalog item endpoints. Path parameters Parameter Required Data Type Description catalog_name Required String Name of the catalog. item_id Required String The ID of the catalog item. Request parameters Parameter Required Data Type Description items Required Array An array that contains item objects. The item objects should contain all of the fields in the catalog except for the id field. Only one item object is allowed per request. Example Request curl -- location -- request POST &#39;https://rest.iad-03.braze.com/catalogs/restaurants/items/restaurant1&#39; -- header &#39;Content-Type: application/json&#39; -- header &#39;Authorization: Bearer YOUR-REST-API-KEY&#39; -- data - raw &#39;{ &quot;items&quot;: [ { &quot;Name&quot;: &quot;Restaurant1&quot;, &quot;City&quot;: &quot;New York&quot;, &quot;Cuisine&quot;: &quot;American&quot;, &quot;Rating&quot;: 5, &quot;Loyalty_Program&quot;: true, &quot;Created_At&quot;: &quot;2022-11-01T09:03:19.967+00:00&quot; } ] }&#39; Response There are three status code responses for this endpoint: 201 , 400 , and 404 . Example success response The status code 201 could return the following response body. { &quot;message&quot;: &quot;success&quot; } Example error response The status code 400 could return the following response body. Refer to Troubleshooting for more information about errors you may encounter. { &quot;errors&quot;: [ { &quot;id&quot;: &quot;fields-do-not-match&quot;, &quot;message&quot;: &quot;Fields do not match with fields on the catalog&quot;, &quot;parameters&quot;: [ &quot;id&quot; ], &quot;parameter_values&quot;: [ &quot;restaurant2&quot; ] } ], &quot;message&quot;: &quot;Invalid Request&quot; } Troubleshooting The following table lists possible returned errors and their associated troubleshooting steps. Error Troubleshooting catalog-not-found Check that the catalog name is valid. item-array-invalid items must be an array of objects. request-includes-too-many-items You can only create one catalog item per request. id-in-body Remove any item IDs in the request body. invalid-ids Supported characters for item ID names are letters, numbers, hyphens, and underscores. ids-too-large Character limit for each item ID is 250 characters. items-too-large Character limit for each item is 5,000 characters. item-already-exists The item already exists in the catalog. invalid-fields Confirm that the fields in the request exist in the catalog. fields-do-not-match Fields must match the fields in the catalog. filtered-set-field-too-long The field value is being used in a filtered set that exceeds the character limit for an item. already-reached-catalog-item-limit Maximum number of catalogs reached. Contact your Braze account manager for more information. already-reached-company-item-limit Maximum number of catalog items reached. Contact your Braze account manager for more information. unable-to-coerce-value Item types can't be converted. arbitrary-error An arbitrary error occurred. Please try again or contact Support . Parameters connection (BrazeEx.Connection): Connection to server catalog_name (String.t): item_id (String.t): opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.CatalogsCatalogItemsSynchronous.html#catalogs_catalog_name_items_item_id_post/4","title":"BrazeEx.Api.CatalogsCatalogItemsSynchronous.catalogs_catalog_name_items_item_id_post/4","type":"function"},{"doc":"API calls for all endpoints tagged CatalogsCatalogManagementSynchronous .","ref":"BrazeEx.Api.CatalogsCatalogManagementSynchronous.html","title":"BrazeEx.Api.CatalogsCatalogManagementSynchronous","type":"module"},{"doc":"Delete Catalog Use this endpoint to delete a catalog. Rate limit This endpoint has a shared rate limit of 5 requests per minute between all synchronous catalog endpoints. Path parameters Parameter Required Data Type Description catalog_name Required String Name of the catalog. Response There are two status code responses for this endpoint: 200 and 404 . Example success response The status code 200 could return the following response body. { &quot;message&quot;: &quot;success&quot; } Example error response The status code 404 could return the following response body. Refer to Troubleshooting for more information about errors you may encounter. { &quot;errors&quot;: [ { &quot;id&quot;: &quot;catalog-not-found&quot;, &quot;message&quot;: &quot;Could not find catalog&quot;, &quot;parameters&quot;: [ &quot;catalog_name&quot; ], &quot;parameter_values&quot;: [ &quot;restaurants&quot; ] } ], &quot;message&quot;: &quot;Invalid Request&quot; } Troubleshooting The following table lists possible returned errors and their associated troubleshooting steps. Error Troubleshooting catalog-not-found Check that the catalog name is valid. Parameters connection (BrazeEx.Connection): Connection to server catalog_name (String.t): opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.CatalogsCatalogManagementSynchronous.html#catalogs_catalog_name_delete/3","title":"BrazeEx.Api.CatalogsCatalogManagementSynchronous.catalogs_catalog_name_delete/3","type":"function"},{"doc":"List Catalogs in App Group Use this endpoint to return a list of catalogs in an app group. Path parameters There are no path parameters for this endpoint. Request parameters There is no request body for this endpoint. Response Example success response The status code 200 could return the following response body. { &quot;catalogs&quot;: [ { &quot;description&quot;: &quot;My Restaurants&quot;, &quot;fields&quot;: [ { &quot;name&quot;: &quot;id&quot;, &quot;type&quot;: &quot;string&quot; }, { &quot;name&quot;: &quot;Name&quot;, &quot;type&quot;: &quot;string&quot; }, { &quot;name&quot;: &quot;City&quot;, &quot;type&quot;: &quot;string&quot; }, { &quot;name&quot;: &quot;Cuisine&quot;, &quot;type&quot;: &quot;string&quot; }, { &quot;name&quot;: &quot;Rating&quot;, &quot;type&quot;: &quot;number&quot; }, { &quot;name&quot;: &quot;Loyalty_Program&quot;, &quot;type&quot;: &quot;boolean&quot; }, { &quot;name&quot;: &quot;Created_At&quot;, &quot;type&quot;: &quot;time&quot; } ], &quot;name&quot;: &quot;restaurants&quot;, &quot;num_items&quot;: 10, &quot;updated_at&quot;: &quot;2022-11-02T20:04:06.879+00:00&quot; }, { &quot;description&quot;: &quot;My Catalog&quot;, &quot;fields&quot;: [ { &quot;name&quot;: &quot;id&quot;, &quot;type&quot;: &quot;string&quot; }, { &quot;name&quot;: &quot;string_field&quot;, &quot;type&quot;: &quot;string&quot; }, { &quot;name&quot;: &quot;number_field&quot;, &quot;type&quot;: &quot;number&quot; }, { &quot;name&quot;: &quot;boolean_field&quot;, &quot;type&quot;: &quot;boolean&quot; }, { &quot;name&quot;: &quot;time_field&quot;, &quot;type&quot;: &quot;time&quot; }, ], &quot;name&quot;: &quot;my_catalog&quot;, &quot;num_items&quot;: 3, &quot;updated_at&quot;: &quot;2022-11-02T09:03:19.967+00:00&quot; }, ], &quot;message&quot;: &quot;success&quot; } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.CatalogsCatalogManagementSynchronous.html#catalogs_get/2","title":"BrazeEx.Api.CatalogsCatalogManagementSynchronous.catalogs_get/2","type":"function"},{"doc":"Create Catalog Use this endpoint to create a catalog. Rate limit This endpoint has a shared rate limit of 5 requests per minute between all synchronous catalog endpoints. Request parameters Parameter Required Data Type Description catalogs Required Array An array that contains catalog objects. Only one catalog object is allowed for this request. Catalog object parameters Parameter Required Data Type Description name Required String The name of the catalog that you want to create. description Required String The description of the catalog that you want to create. fields Required Array An array of objects where the object contains keys name and type . Example Request curl -- location -- request POST &#39;https://rest.iad-03.braze.com/catalogs&#39; -- header &#39;Content-Type: application/json&#39; -- header &#39;Authorization: Bearer YOUR-REST-API-KEY&#39; -- data - raw &#39;{ &quot;catalogs&quot;: [ { &quot;name&quot;: &quot;restaurants&quot;, &quot;description&quot;: &quot;My Restaurants&quot;, &quot;fields&quot;: [ { &quot;name&quot;: &quot;id&quot;, &quot;type&quot;: &quot;string&quot; }, { &quot;name&quot;: &quot;Name&quot;, &quot;type&quot;: &quot;string&quot; }, { &quot;name&quot;: &quot;City&quot;, &quot;type&quot;: &quot;string&quot; }, { &quot;name&quot;: &quot;Cuisine&quot;, &quot;type&quot;: &quot;string&quot; }, { &quot;name&quot;: &quot;Rating&quot;, &quot;type&quot;: &quot;number&quot; }, { &quot;name&quot;: &quot;Loyalty_Program&quot;, &quot;type&quot;: &quot;boolean&quot; }, { &quot;name&quot;: &quot;Created_At&quot;, &quot;type&quot;: &quot;time&quot; } ] } ] }&#39; Response There are two status code responses for this endpoint: 201 and 400 . Example success response The status code 201 could return the following response body. { &quot;catalogs&quot;: [ { &quot;description&quot;: &quot;My Restaurants&quot;, &quot;fields&quot;: [ { &quot;name&quot;: &quot;id&quot;, &quot;type&quot;: &quot;string&quot; }, { &quot;name&quot;: &quot;Name&quot;, &quot;type&quot;: &quot;string&quot; }, { &quot;name&quot;: &quot;City&quot;, &quot;type&quot;: &quot;string&quot; }, { &quot;name&quot;: &quot;Cuisine&quot;, &quot;type&quot;: &quot;string&quot; }, { &quot;name&quot;: &quot;Rating&quot;, &quot;type&quot;: &quot;number&quot; }, { &quot;name&quot;: &quot;Loyalty_Program&quot;, &quot;type&quot;: &quot;boolean&quot; }, { &quot;name&quot;: &quot;Created_At&quot;, &quot;type&quot;: &quot;time&quot; } ], &quot;name&quot;: &quot;restaurants&quot;, &quot;num_items&quot;: 0, &quot;updated_at&quot;: &quot;2022-11-02T20:04:06.879+00:00&quot; } ], &quot;message&quot;: &quot;success&quot; } Example error response The status code 400 could return the following response body. Refer to Troubleshooting for more information about errors you may encounter. { &quot;errors&quot;: [ { &quot;id&quot;: &quot;catalog-name-already-exists&quot;, &quot;message&quot;: &quot;A catalog with that name already exists&quot;, &quot;parameters&quot;: [ &quot;name&quot; ], &quot;parameter_values&quot;: [ &quot;restaurants&quot; ] } ], &quot;message&quot;: &quot;Invalid Request&quot; } Troubleshooting The following table lists possible returned errors and their associated troubleshooting steps. Error Troubleshooting catalog-array-invalid catalogs must be an array of objects. too-many-catalog-atoms You can only create one catalog per request. invalid_catalog_name Catalog name can only include letters, numbers, hyphens, and underscores. catalog-name-too-large Character limit for a catalog name is 250. catalog-name-already-exists Catalog with that name already exists. id-not-first-column The id must be the first field in the array. Check that the type is a string. invalid-fields fields is not formatted correctly. too-many-fields Number of fields limit is 30. invalid-field-names Fields can only include letters, numbers, hyphens, and underscores. invalid-field-types Make sure the field types are valid. field-names-too-large Character limit for a field name is 250. field-names-not-unique The same field name is referenced twice. reached-company-catalogs-limit Maximum number of catalogs reached. Contact your Braze account manager for more information. description-too-long Character limit for description is 250. Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.CatalogsCatalogManagementSynchronous.html#catalogs_post/2","title":"BrazeEx.Api.CatalogsCatalogManagementSynchronous.catalogs_post/2","type":"function"},{"doc":"API calls for all endpoints tagged EmailListsAddresses .","ref":"BrazeEx.Api.EmailListsAddresses.html","title":"BrazeEx.Api.EmailListsAddresses","type":"module"},{"doc":"Blacklist Email Addresses Braze has released the  /email/blocklist  endpoint  with the same functionality as the  /email/blacklist  endpoint. It is recommended to use the  /email/blocklist  endpoint instead. Use this endpoint to unsubscribe a user from email and mark them as hard bounced. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Request parameters Parameter Required Data Type Description email Required String or array String email address to blacklist, or an array of up to 50 email addresses to blacklist. Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.EmailListsAddresses.html#email_blacklist_post/2","title":"BrazeEx.Api.EmailListsAddresses.email_blacklist_post/2","type":"function"},{"doc":"Blocklist Email Addresses Use this endpoint to unsubscribe a user from email and mark them as hard bounced. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Request parameters Parameter Required Data Type Description email Required String or array String email address to blacklist, or an array of up to 50 email addresses to blocklist. Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.EmailListsAddresses.html#email_blocklist_post/2","title":"BrazeEx.Api.EmailListsAddresses.email_blocklist_post/2","type":"function"},{"doc":"Remove Hard Bounced Emails Use this endpoint to remove email addresses from your Braze bounce list. We will also remove them from the bounce list maintained by your email provider. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Request parameters Parameter Required Data Type Description email Required String or array String email address to modify, or an array of up to 50 email addresses to modify. Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.EmailListsAddresses.html#email_bounce_remove_post/2","title":"BrazeEx.Api.EmailListsAddresses.email_bounce_remove_post/2","type":"function"},{"doc":"Query Hard Bounced Emails Use this endpoint to pull a list of email addresses that have “hard bounced” your email messages within a certain time frame. Note: You must provide an end_date , as well as either an email or a start_date . If you provide all three, start_date , end_date , and an email , we prioritize the emails given and disregard the date range. If your date range has more than limit number of hard bounces, you will need to make multiple API calls, each time increasing the offset until a call returns either fewer than limit or zero results. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Entries are listed in descending order. Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;emails&quot;: [ { &quot;email&quot;: &quot;example1@braze.com&quot;, &quot;hard_bounced_at&quot;: &quot;2016-08-25 15:24:32 +0000&quot; }, { &quot;email&quot;: &quot;example2@braze.com&quot;, &quot;hard_bounced_at&quot;: &quot;2016-08-24 17:41:58 +0000&quot; }, { &quot;email&quot;: &quot;example3@braze.com&quot;, &quot;hard_bounced_at&quot;: &quot;2016-08-24 12:01:13 +0000&quot; } ], &quot;message&quot;: &quot;success&quot; } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :start_date (String.t): (Optional ) String in YYYY-MM-DD format Start date of the range to retrieve hard bounces, must be earlier than end_date . This is treated as midnight in UTC time by the API. You must provide either an email or a start_date , and an end_date . :end_date (String.t): (Optional ) String in YYYY-MM-DD format String in YYYY-MM-DD format. End date of the range to retrieve hard bounces. This is treated as midnight in UTC time by the API. You must provide either an email or a start_date , and an end_date . :limit (integer()): (Optional) Integer Optional field to limit the number of results returned. Defaults to 100, maximum is 500. :offset (integer()): (Optional) Integer Optional beginning point in the list to retrieve from. :email (String.t): (Optional ) String If provided, we will return whether or not the user has hard bounced. You must provide either an email or a start_date , and an end_date . Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.EmailListsAddresses.html#email_hard_bounces_get/2","title":"BrazeEx.Api.EmailListsAddresses.email_hard_bounces_get/2","type":"function"},{"doc":"Remove Email Addresses from Spam List Use this endpoint to remove email addresses from your Braze spam list. We will also remove them from the spam list maintained by your email provider. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Request parameters Parameter Required Data Type Description email Required String or array String email address to modify, or an array of up to 50 email addresses to modify. Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.EmailListsAddresses.html#email_spam_remove_post/2","title":"BrazeEx.Api.EmailListsAddresses.email_spam_remove_post/2","type":"function"},{"doc":"Change Email Subscription Status Use this endpoint to set the email subscription state for your users. Users can be  opted_in ,  unsubscribed , or  subscribed  (not specifically opted in or out). You can set the email subscription state for an email address that is not yet associated with any of your users within Braze. When that email address is subsequently associated with a user, the email subscription state that you uploaded will be automatically set. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Request parameters Parameter Required Data Type Description email Required String or array String email address to modify, or an array of up to 50 email addresses to modify. subscription_state Required String Either “subscribed”, “unsubscribed”, or “opted_in”. Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.EmailListsAddresses.html#email_status_post/2","title":"BrazeEx.Api.EmailListsAddresses.email_status_post/2","type":"function"},{"doc":"Query List of Unsubscribed Email Addresses Use this endpoint to return emails that have unsubscribed during the time period from  start_date  to  end_date . You can use this endpoint to set up a bi-directional sync between Braze and other email systems or your own database. Note: You must provide an end_date , as well as either an email or a start_date . If your date range has more than limit number of unsubscribes, you will need to make multiple API calls, each time increasing the offset until a call returns either fewer than limit or zero results. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Entries are listed in descending order. Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;emails&quot;: [ { &quot;email&quot;: &quot;example1@braze.com&quot;, &quot;unsubscribed_at&quot;: &quot;2016-08-25 15:24:32 +0000&quot; }, { &quot;email&quot;: &quot;example2@braze.com&quot;, &quot;unsubscribed_at&quot;: &quot;2016-08-24 17:41:58 +0000&quot; }, { &quot;email&quot;: &quot;example3@braze.com&quot;, &quot;unsubscribed_at&quot;: &quot;2016-08-24 12:01:13 +0000&quot; } ], &quot;message&quot;: &quot;success&quot; } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :start_date (String.t): (Optional*) String in YYYY-MM-DD format Start date of the range to retrieve unsubscribes, must be earlier than end_date. This is treated as midnight in UTC time by the API. :end_date (String.t): (Optional*) String in YYYY-MM-DD format End date of the range to retrieve unsubscribes. This is treated as midnight in UTC time by the API. :limit (integer()): (Optional) Integer Optional field to limit the number of results returned. Limit must be greater than 1. Defaults to 100, maximum is 500. :offset (integer()): (Optional) Integer Optional beginning point in the list to retrieve from. :sort_direction (String.t): (Optional) String Pass in the value asc to sort unsubscribes from oldest to newest. Pass in desc to sort from newest to oldest. If sort_direction is not included, the default order is newest to oldest. :email (String.t): (Optional*) String If provided, we will return whether or not the user has unsubscribed. Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.EmailListsAddresses.html#email_unsubscribes_get/2","title":"BrazeEx.Api.EmailListsAddresses.email_unsubscribes_get/2","type":"function"},{"doc":"API calls for all endpoints tagged ExportCampaign .","ref":"BrazeEx.Api.ExportCampaign.html","title":"BrazeEx.Api.ExportCampaign","type":"module"},{"doc":"Campaign Analytics Use this endpoint to retrieve a daily series of various stats for a campaign over time. Data returned includes how many messages were sent, opened, clicked, or converted by messaging channel. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Responses Multichannel response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;message&quot;: (required, string) the status of the export, returns 'success' when completed without errors, &quot;data&quot; : [ { &quot;time&quot; : (string) date as ISO 8601 date, &quot;messages&quot; : { &quot;ios_push&quot; : [ { &quot;variation_name&quot;: &quot;iOS_Push&quot;, &quot;sent&quot; : (int), &quot;direct_opens&quot; : (int), &quot;total_opens&quot; : (int), &quot;bounces&quot; : (int), &quot;body_clicks&quot; : (int) &quot;revenue&quot;: 0, &quot;unique_recipients&quot;: 1, &quot;conversions&quot;: 0, &quot;conversions_by_send_time&quot;: 0, &quot;conversions1&quot;: 0, &quot;conversions1_by_send_time&quot;: 0, &quot;conversions2&quot;: 0, &quot;conversions2_by_send_time&quot;: 0, &quot;conversions3&quot;: 0, &quot;conversions3_by_send_time&quot;: 0, &quot;carousel_slide_[NUM]_[TITLE]_click&quot;: (optional, int), &quot;notif_button_[NUM]_[TITLE]_click&quot;: (optional, int) } ], &quot;android_push&quot; : [ { &quot;sent&quot; : (int), &quot;direct_opens&quot; : (int), &quot;total_opens&quot; : (int), &quot;bounces&quot; : (int), &quot;body_clicks&quot; : (int) } ], &quot;webhook&quot;: [ { &quot;sent&quot;: (int), &quot;errors&quot;: (int) } ], &quot;email&quot; : [ { &quot;sent&quot;: (int), &quot;opens&quot;: (int), &quot;unique_opens&quot;: (int), &quot;clicks&quot;: (int), &quot;unique_clicks&quot;: (int), &quot;unsubscribes&quot;: (int), &quot;bounces&quot;: (int), &quot;delivered&quot;: (int), &quot;reported_spam&quot;: (int) } ], &quot;sms&quot; : [ { &quot;sent&quot;: (int), &quot;delivered&quot;: (int), &quot;undelivered&quot;: (int), &quot;delivery_failed&quot;: (int) } ] }, &quot;conversions_by_send_time&quot;: (optional, int), &quot;conversions1_by_send_time&quot;: (optional, int), &quot;conversions2_by_send_time&quot;: (optional, int), &quot;conversions3_by_send_time&quot;: (optional, int), &quot;conversions&quot;: (int), &quot;conversions1&quot;: (optional, int), &quot;conversions2&quot;: (optional, int), &quot;conversions3&quot;: (optional, int), &quot;unique_recipients&quot;: (int), &quot;revenue&quot;: (optional, float) }, ... ], ... } Multivariate response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;data&quot; : [ { &quot;time&quot; : (string) date as ISO 8601 date, &quot;conversions&quot; : (int), &quot;revenue&quot;: (float), &quot;conversions_by_send_time&quot;: (int), &quot;messages&quot; : { &quot;trigger_in_app_message&quot;: [{ &quot;variation_name&quot;: (optional, string), &quot;impressions&quot;: (int), &quot;clicks&quot;: (int), &quot;first_button_clicks&quot;: (int), &quot;second_button_clicks&quot;: (int), &quot;revenue&quot;: (optional, float),, &quot;unique_recipients&quot;: (int), &quot;conversions&quot;: (optional, int), &quot;conversions_by_send_time&quot;: (optional, int), &quot;conversions1&quot;: (optional, int), &quot;conversions1_by_send_time&quot;: (optional, int), &quot;conversions2&quot;: (optional, int), &quot;conversions2_by_send_time&quot;: (optional, int), &quot;conversions3&quot;: (optional, int), &quot;conversions3_by_send_time&quot;: (optional, int) }, { &quot;variation_name&quot;: (optional, string), &quot;impressions&quot;: (int), &quot;clicks&quot;: (int), &quot;first_button_clicks&quot;: (int), &quot;second_button_clicks&quot;: (int), &quot;revenue&quot;: (optional, float),, &quot;unique_recipients&quot;: (int), &quot;conversions&quot;: (optional, int), &quot;conversions_by_send_time&quot;: (optional, int), &quot;conversions1&quot;: (optional, int), &quot;conversions1_by_send_time&quot;: (optional, int), &quot;conversions2&quot;: (optional, int), &quot;conversions2_by_send_time&quot;: (optional, int), &quot;conversions3&quot;: (optional, int). &quot;conversions3_by_send_time&quot;: (optional, int) }, { &quot;variation_name&quot;: (optional, string), &quot;revenue&quot;: (optional, float),, &quot;unique_recipients&quot;: (int), &quot;conversions&quot;: (optional, int), &quot;conversions_by_send_time&quot;: (optional, int), &quot;conversions1&quot;: (optional, int), &quot;conversions1_by_send_time&quot;: (optional, int), &quot;conversions2&quot;: (optional, int), &quot;conversions2_by_send_time&quot;: (optional, int), &quot;conversions3&quot;: (optional, int), &quot;conversions3_by_send_time&quot;: (optional, int), &quot;enrolled&quot;: (optional, int) }] }, &quot;conversions_by_send_time&quot;: (optional, int), &quot;conversions1_by_send_time&quot;: (optional, int), &quot;conversions2_by_send_time&quot;: (optional, int), &quot;conversions3_by_send_time&quot;: (optional, int), &quot;conversions&quot;: (optional, int, &quot;conversions1&quot;: (optional, int), &quot;conversions2&quot;: (optional, int), &quot;conversions3&quot;: (optional, int), &quot;unique_recipients&quot;: (int), &quot;revenue&quot;: (optional, float) }], ... } Possible message types are email , in_app_message , webhook , android_push , apple_push , kindle_push , web_push , windows_phone8_push , and windows_universal_push . All push message types will have the same statistics shown for android_push above. Tip: For help with CSV and API exports, visit Export troubleshooting . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :campaign_id (String.t): (Required) String See campaign API identifier . The campaign_id for API campaigns can be found on the Developer Console and the campaign details page within your dashboard, or you can use the Campaign List Endpoint . :length (integer()): (Required) Integer Max number of days before ending_at to include in the returned series. Must be between 1 and 100 (inclusive). :ending_at (String.t): (Optional) Datetime ( ISO 8601 string) Date on which the data series should end. Defaults to time of the request. Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportCampaign.html#campaigns_data_series_get/2","title":"BrazeEx.Api.ExportCampaign.campaigns_data_series_get/2","type":"function"},{"doc":"Campaign Details Use this endpoint to retrieve relevant information on a specified campaign, which can be identified by the  campaign_id . If you want to retrieve Canvas data, refer to the  Canvas Details  endpoint. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Responses Campaign details endpoint API response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;message&quot;: (required, string) the status of the export, returns 'success' when completed without errors, &quot;created_at&quot; : (string) date created as ISO 8601 date, &quot;updated_at&quot; : (string) date last updated as ISO 8601 date, &quot;archived&quot;: (boolean) whether this Campaign is archived, &quot;draft&quot;: (boolean) whether this Campaign is a draft, &quot;name&quot; : (string) campaign name, &quot;description&quot; : (string) campaign description, &quot;schedule_type&quot; : (string) type of scheduling action, &quot;channels&quot; : (array) list of channels to send via, &quot;first_sent&quot; : (string) date and hour of first sent as ISO 8601 date, &quot;last_sent&quot; : (string) date and hour of last sent as ISO 8601 date, &quot;tags&quot; : (array) tag names associated with the campaign, &quot;messages&quot;: { &quot;message_variation_id&quot;: (string) { // &lt;=This is the actual id &quot;channel&quot;: (string) channel type of the message (as in, &quot;email&quot;, &quot;ios_push&quot;, &quot;webhook&quot;, &quot;content_card&quot;, &quot;in-app_message&quot;, &quot;sms&quot;), &quot;name&quot;: (string) name of the message in the Dashboard (eg., &quot;Variation 1&quot;) ... channel-specific fields for this message, see below ... } }, &quot;conversion_behaviors&quot;: (array) conversion event behaviors assigned to the campaign (see below) } Messages The messages response will contain information about each message. The following includes example message responses for each channel: Push channels { &quot;channel&quot;: (string) description of the channel, such as &quot;ios_push&quot; or &quot;android_push&quot; &quot;alert&quot;: (string) alert body text, &quot;extras&quot;: (hash) any key value pairs provided } Email channel { &quot;channel&quot;: &quot;email&quot;, &quot;subject&quot;: (string) subject, &quot;body&quot;: (string) HTML body, &quot;from&quot;: (string) from address and display name, &quot;reply_to&quot;: (string) reply-to for message, if different than &quot;from&quot; address, &quot;title&quot;: (string) name of the email, &quot;extras&quot;: (hash) any key value pairs provided } In-app message channel { &quot;type&quot;: (string) description of in-app message type, such as &quot;survey&quot;, &quot;data&quot;: { &quot;pages&quot;: [ { &quot;header&quot;: { &quot;text&quot;:(string) display text for the header of the survey, } &quot;choices&quot;: [ { &quot;choice_id&quot;: (string) choice identifier, &quot;text&quot;: (string) display text, &quot;custom_attribute_key&quot;: (string) custom attribute key, &quot;custom_attribute_value&quot;: (sting) custom attribute value, &quot;deleted&quot;: (boolean) deleted from live campaign, }, ... ] } ] } } Content Card channel { &quot;channel&quot;: &quot;content_cards&quot;, &quot;name&quot;: (string) name of variant, &quot;extras&quot;: (hash) any key value pairs provided; only present if at least one key-value pair has been set } Webhook channel { &quot;channel&quot;: &quot;webhook&quot;, &quot;url&quot;: (string) url for webhook, &quot;body&quot;: (string) payload body, &quot;type&quot;: (string) body content type, &quot;headers&quot;: (hash) specified request headers, &quot;method&quot;: (string) HTTP method (e.g., &quot;POST&quot; or &quot;GET&quot;), } SMS channel { &quot;channel&quot;: &quot;sms&quot;, &quot;body&quot;: (string) payload body, &quot;from&quot;: (string) list of numbers associated with the subscription group, &quot;subscription_group_id&quot;: (string) API id of the subscription group targeted in the SMS message } Control Messages { &quot;channel&quot;: (string) description of the channel that the control is for, &quot;type&quot;: &quot;control&quot; } Conversion Behaviors The conversion_behaviors array will contain information about each conversion event behavior set for the campaign. These behaviors are in order as set by the campaign. For example, Conversion Event A will be the first item in the array, Conversion Event B will be second, etc. The following lists example conversion event behavior responses: Clicks email { &quot;type&quot;: &quot;Clicks Email&quot;, &quot;window&quot;: (integer) number of seconds during which the user can convert on this event, i.e. - 86400, which is 24 hours } Opens email { &quot;type&quot;: &quot;Opens Email&quot;, &quot;window&quot;: (integer) number of seconds during which the user can convert on this event, i.e. - 86400, which is 24 hours } Makes purchase (any purchase) { &quot;type&quot;: &quot;Makes Any Purchase&quot;, &quot;window&quot;: (integer) number of seconds during which the user can convert on this event, i.e. - 86400, which is 24 hours } Makes purchase (specific product) { &quot;type&quot;: &quot;Makes Specific Purchase&quot;, &quot;window&quot;: (integer) number of seconds during which the user can convert on this event, i.e. - 86400, which is 24 hours, &quot;product&quot;: (string) name of the product, i.e. - &quot;Feline Body Armor&quot; } Performs custom event { &quot;type&quot;: &quot;Performs Custom Event&quot;, &quot;window&quot;: (integer) number of seconds during which the user can convert on this event, i.e. - 86400, which is 24 hours, &quot;custom_event_name&quot;: (string) name of the event, i.e. - &quot;Used Feline Body Armor&quot; } Upgrades app { &quot;type&quot;: &quot;Upgrades App&quot;, &quot;window&quot;: (integer) number of seconds during which the user can convert on this event, i.e. - 86400, which is 24 hours, &quot;app_ids&quot;: (array|null) array of app ids, i.e. - [&quot;12345&quot;, &quot;67890&quot;], or `null` if &quot;Track sessions for any app&quot; is selected in the UI } Uses app { &quot;type&quot;: &quot;Starts Session&quot;, &quot;window&quot;: (integer) number of seconds during which the user can convert on this event, i.e. - 86400, which is 24 hours, &quot;app_ids&quot;: (array|null) array of app ids, i.e. - [&quot;12345&quot;, &quot;67890&quot;], or `null` if &quot;Track sessions for any app&quot; is selected in the UI } Tip: For help with CSV and API exports, visit Export troubleshooting . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :campaign_id (String.t): (Required) String See campaign API identifier . The campaign_id for API campaigns can be found on the Developer Console and the campaign details page within your dashboard, or you can use the Campaign List Endpoint . Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportCampaign.html#campaigns_details_get/2","title":"BrazeEx.Api.ExportCampaign.campaigns_details_get/2","type":"function"},{"doc":"Campaign List Use this endpoint to export a list of campaigns, each of which will include its name, campaign API identifier, whether it is an API campaign, and tags associated with the campaign. The campaigns are returned in groups of 100 sorted by time of creation (oldest to newest by default). Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Campaign list endpoint API response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;message&quot;: (required, string) the status of the export, returns 'success' when completed without errors, &quot;campaigns&quot; : [ { &quot;id&quot; : (string) Campaign API Identifier, &quot;last_edited&quot;: (ISO 8601 string) the last edited time for the message &quot;name&quot; : (string) campaign name, &quot;is_api_campaign&quot; : (boolean) whether the campaign is an API Campaign, &quot;tags&quot; : (array) tag names associated with the campaign }, ... ] } Tip: For help with CSV and API exports, visit Export troubleshooting . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :page (integer()): (Optional) Integer The page of campaigns to return, defaults to 0 (returns the first set of up to 100). :include_archived (boolean()): (Optional) Boolean Whether or not to include archived campaigns, defaults to false. :sort_direction (String.t): (Optional) String - Sort creation time from newest to oldest: pass in the value desc . - Sort creation time from oldest to newest: pass in the value asc . If sort_direction is not included, the default order is oldest to newest. :last_edit_periodtime_left_square_bracketgt_right_square_bracket (String.t): (Optional) Datetime ( ISO 8601 string) Filters the results and only returns campaigns that were edited greater than the time provided till now. Format is yyyy-MM-DDTHH:mm:ss . Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportCampaign.html#campaigns_list_get/2","title":"BrazeEx.Api.ExportCampaign.campaigns_list_get/2","type":"function"},{"doc":"Send Analytics Use this endpoint to retrieve a daily series of various stats for a tracked  send_id . Braze stores send analytics for 14 days after the send. Campaign conversions will be attributed towards the most recent send id that a given user has received from the campaign. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Send analytics endpoint API response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;variation_name&quot;: (string) variation name, &quot;sent&quot;: (int) the number of sends, &quot;delivered&quot;: (int) the number of messages successfully delivered, &quot;undelivered&quot;: (int) the number of undelivered, &quot;delivery_failed&quot;: (int) the number of rejected, &quot;direct_opens&quot;: (int) the number of direct opens, &quot;total_opens&quot;: (int) the number of total opens, &quot;bounces&quot;: (int) the number of bounces, &quot;body_clicks&quot;: (int) the number of body clicks, &quot;revenue&quot;: (float) the number of dollars of revenue (USD), &quot;unique_recipients&quot;: (int) the number of unique recipients, &quot;conversions&quot;: (int) the number of conversions, &quot;conversions_by_send_time&quot;: (int) the number of conversions, &quot;conversions1&quot;: (int, optional) the number of conversions for the second conversion event, &quot;conversions1_by_send_time&quot;: (int, optional) the number of conversions for the second conversion event by send time, &quot;conversions2&quot;: (int, optional) the number of conversions for the third conversion event, &quot;conversions2_by_send_time&quot;: (int, optional) the number of conversions for the third conversion event by send time, &quot;conversions3&quot;: (int, optional) the number of conversions for the fourth conversion event, &quot;conversions3_by_send_time&quot;: (int, optional) the number of conversions for the fourth conversion event by send time } ] }, &quot;conversions_by_send_time&quot;: 0, &quot;conversions1_by_send_time&quot;: 0, &quot;conversions2_by_send_time&quot;: 0, &quot;conversions3_by_send_time&quot;: 0, &quot;conversions&quot;: 0, &quot;conversions1&quot;: 0, &quot;conversions2&quot;: 0, &quot;conversions3&quot;: 0, &quot;unique_recipients&quot;: 1, &quot;revenue&quot;: 0 } ], &quot;message&quot;: &quot;success&quot; } Tip: For help with CSV and API exports, visit Export troubleshooting . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :campaign_id (String.t): (Required) String See Campaign API identifier . :send_id (String.t): (Required) String See Send API identifier . :length (integer()): (Required) Integer Max number of days before ending_at to include in the returned series. Must be between 1 and 100 (inclusive). :ending_at (String.t): (Optional) Datetime ( ISO 8601 string) Date on which the data series should end. Defaults to time of the request. Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportCampaign.html#sends_data_series_get/2","title":"BrazeEx.Api.ExportCampaign.sends_data_series_get/2","type":"function"},{"doc":"API calls for all endpoints tagged ExportCanvas .","ref":"BrazeEx.Api.ExportCanvas.html","title":"BrazeEx.Api.ExportCanvas","type":"module"},{"doc":"Canvas Data Series Analytics Use this endpoint to export time series data for a Canvas. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;data&quot;: { &quot;name&quot;: (string) Canvas name, &quot;stats&quot;: [ { &quot;time&quot;: (string) date as ISO 8601 date, &quot;total_stats&quot;: { &quot;revenue&quot;: (float), &quot;conversions&quot;: (int), &quot;conversions_by_entry_time&quot;: (int), &quot;entries&quot;: (int) }, &quot;variant_stats&quot;: (optional) { &quot;00000000-0000-0000-0000-0000000000000&quot;: (API identifier for variant) { &quot;name&quot;: (string) name of variant, &quot;revenue&quot;: (int), &quot;conversions&quot;: (int), &quot;conversions_by_entry_time&quot;: (int), &quot;entries&quot;: (int) }, ... (more variants) }, &quot;step_stats&quot;: (optional) { &quot;00000000-0000-0000-0000-0000000000000&quot;: (API identifier for step) { &quot;name&quot;: (string) name of step, &quot;revenue&quot;: (float), &quot;conversions&quot;: (int), &quot;conversions_by_entry_time&quot;: (int), &quot;messages&quot;: { &quot;email&quot;: [ { &quot;sent&quot;: (int), &quot;opens&quot;: (int), &quot;unique_opens&quot;: (int), &quot;clicks&quot;: (int), ... (more stats) } ], ... (more channels) } }, ... (more steps) } }, ... (more stats by time) ] }, &quot;message&quot;: (required, string) the status of the export, returns 'success' when completed without errors } Tip: For help with CSV and API exports, visit Export troubleshooting . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :canvas_id (String.t): (Required) String See Canvas API Identifier . :ending_at (String.t): (Required) Datetime ( ISO 8601 string) Date on which the data export should end. Defaults to time of the request. :starting_at (String.t): (Optional ) Datetime ( ISO 8601 string) Date on which the data export should begin. Either length or starting_at is required. :length (integer()): (Optional ) Datetime ( ISO 8601 string) Maximum number of days before ending_at to include in the returned series. Must be between 1 and 14 (inclusive). Either length or starting_at is required. :include_variant_breakdown (boolean()): (Optional) Boolean Whether or not to include variant stats (defaults to false). :include_step_breakdown (boolean()): (Optional) Boolean Whether or not to include step stats (defaults to false). :include_deleted_step_data (boolean()): (Optional) Boolean Whether or not to include step stats for deleted steps (defaults to false). Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportCanvas.html#canvas_data_series_get/2","title":"BrazeEx.Api.ExportCanvas.canvas_data_series_get/2","type":"function"},{"doc":"Canvas Data Analytics Summary Use this endpoint allows to export rollups of time series data for a Canvas, providing a concise summary of a Canvas’ results. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;data&quot;: { &quot;name&quot;: (string) Canvas name, &quot;total_stats&quot;: { &quot;revenue&quot;: (float), &quot;conversions&quot;: (int), &quot;conversions_by_entry_time&quot;: (int), &quot;entries&quot;: (int) }, &quot;variant_stats&quot;: (optional) { &quot;00000000-0000-0000-0000-0000000000000&quot;: (API identifier for variant) { &quot;name&quot;: (string) name of variant, &quot;revenue&quot;: (float), &quot;conversions&quot;: (int), &quot;entries&quot;: (int) }, ... (more variants) }, &quot;step_stats&quot;: (optional) { &quot;00000000-0000-0000-0000-0000000000000&quot;: (API identifier for step) { &quot;name&quot;: (string) name of step, &quot;revenue&quot;: (float), &quot;conversions&quot;: (int), &quot;conversions_by_entry_time&quot;: (int), &quot;messages&quot;: { &quot;android_push&quot;: (name of channel) [ { &quot;sent&quot;: (int), &quot;opens&quot;: (int), &quot;influenced_opens&quot;: (int), &quot;bounces&quot;: (int) ... (more stats for channel) } ], ... (more channels) } }, ... (more steps) } }, &quot;message&quot;: (required, string) the status of the export, returns 'success' when completed without errors } Tip: For help with CSV and API exports, visit Export troubleshooting . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :canvas_id (String.t): (Required) String See Canvas API identifier . :ending_at (String.t): (Required) Datetime ( ISO 8601 string) Date on which the data export should end. Defaults to time of the request :starting_at (String.t): (Optional ) Datetime ( ISO 8601 string) Date on which the data export should begin. Either length or starting_at is required. :length (integer()): (Optional ) Integer Max number of days before ending_at to include in the returned series. Must be between 1 and 14 (inclusive). Either length or starting_at is required. :include_variant_breakdown (boolean()): (Optional) Boolean Whether or not to include variant stats (defaults to false). :include_step_breakdown (boolean()): (Optional) Boolean Whether or not to include step stats (defaults to false). :include_deleted_step_data (boolean()): (Optional) Boolean Whether or not to include step stats for deleted steps (defaults to false). Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportCanvas.html#canvas_data_summary_get/2","title":"BrazeEx.Api.ExportCanvas.canvas_data_summary_get/2","type":"function"},{"doc":"Canvas Details Use this endpoint to export metadata about a Canvas, such as the name, time created, current status, and more. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;created_at&quot;: (string) date created as ISO 8601 date, &quot;updated_at&quot;: (string) date updated as ISO 8601 date, &quot;name&quot;: (string) Canvas name, &quot;description&quot;: (string) Canvas description, &quot;archived&quot;: (boolean) whether this Canvas is archived, &quot;draft&quot;: (boolean) whether this Canvas is a draft, &quot;schedule_type&quot;: (string) type of scheduling action, &quot;first_entry&quot;: (string) date of first entry as ISO 8601 date, &quot;last_entry&quot;: (string) date of last entry as ISO 8601 date, &quot;channels&quot;: (array of strings) step channels used with Canvas, &quot;variants&quot;: [ { &quot;name&quot;: (string) name of variant, &quot;id&quot;: (string) API identifier of the variant, &quot;first_step_ids&quot;: (array of strings) API identifiers for first steps in variant, &quot;first_step_id&quot;: (string) API identifier of first step in variant (deprecated in November 2017, only included if the variant has only one first step) }, ... (more variations) ], &quot;tags&quot;: (array of strings) tag names associated with the Canvas, &quot;steps&quot;: [ { &quot;name&quot;: (string) name of step, &quot;id&quot;: (string) API identifier of the step, &quot;next_step_ids&quot;: (array of strings) API identifiers of steps following step, &quot;channels&quot;: (array of strings) channels used in step, &quot;messages&quot;: { &quot;message_variation_id&quot;: (string) { // &lt;=This is the actual id &quot;channel&quot;: (string) channel type of the message (eg., &quot;email&quot;), ... channel-specific fields for this message, see Campaign Details Endpoint API Response for example message responses ... } } }, ... (more steps) ], &quot;message&quot;: (required, string) the status of the export, returns 'success' when completed without errors } Tip: For help with CSV and API exports, visit Export troubleshooting . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :canvas_id (String.t): (Required) String See  Canvas API Identifier Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportCanvas.html#canvas_details_get/2","title":"BrazeEx.Api.ExportCanvas.canvas_details_get/2","type":"function"},{"doc":"Canvas List Use this endpoint to export a list of Canvases, including the name, Canvas API identifier and associated tags. Canvases are returned in groups of 100 sorted by time of creation (oldest to newest by default). Archived Canvases will not be included in the API response unless the  include_archived  field is specified. Canvases that are stopped but not archived, however, will be returned by default. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;canvases&quot; : [ { &quot;id&quot; : (string) Canvas API Identifier, &quot;last_edited&quot;: (ISO 8601 string) the last edited time for the message, &quot;name&quot; : (string) Canvas name, &quot;tags&quot; : (array) tag names associated with the Canvas, }, ... (more Canvases) ], &quot;message&quot;: (required, string) the status of the export, returns 'success' when completed without errors } Tip: For help with CSV and API exports, visit Export troubleshooting . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :page (integer()): (Optional) Integer The page of Canvases to return, defaults to 0 (returns the first set of up to 100). :include_archived (boolean()): (Optional) Boolean Whether or not to include archived Canvases, defaults to false . :sort_direction (String.t): (Optional) String - Sort creation time from newest to oldest: pass in the value desc . - Sort creation time from oldest to newest: pass in the value asc . If sort_direction is not included, the default order is oldest to newest. :last_edit_periodtime_left_square_bracketgt_right_square_bracket (String.t): (Optional) Datetime ( ISO 8601 string) Filters the results and only returns Canvases that were edited greater than the time provided till now. Format is yyyy-MM-DDTHH:mm:ss . Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportCanvas.html#canvas_list_get/2","title":"BrazeEx.Api.ExportCanvas.canvas_list_get/2","type":"function"},{"doc":"API calls for all endpoints tagged ExportCustomEvents .","ref":"BrazeEx.Api.ExportCustomEvents.html","title":"BrazeEx.Api.ExportCustomEvents","type":"module"},{"doc":"Custom Events Analytics Use this endpoint to retrieve a series of the number of occurrences of a custom event in your app over a designated time period. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;message&quot;: (required, string) the status of the export, returns 'success' when completed without errors, &quot;data&quot; : [ { &quot;time&quot; : (string) point in time - as ISO 8601 extended when unit is &quot;hour&quot; and as ISO 8601 date when unit is &quot;day&quot;, &quot;count&quot; : (int) }, ... ] } Fatal error response codes The following status codes and associated error messages will be returned if your request encounters a fatal error. Any of these error codes indicate that no data will be processed. Error Code Reason / Cause 400 Bad Request Bad Syntax 401 Unauthorized Unknown or missing REST API Key 429 Rate Limited Over rate limit 5XX Internal server error, you should retry with exponential backoff Tip: For help with CSV and API exports, visit Export troubleshooting . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :event (String.t): (Required) String The name of the custom event for which to return analytics. :length (integer()): (Required) Integer Maximum number of units (days or hours) before ending_at to include in the returned series. Must be between 1 and 100 (inclusive). :unit (String.t): (Optional) String Unit of time between data points - can be day or hour , defaults to day . :ending_at (String.t): (Optional) Datetime ( ISO 8601 string) Date on which the data series should end. Defaults to time of the request. :app_id (String.t): (Optional) String App API identifier retrieved from the Developer Console to limit analytics to a specific app. :segment_id (String.t): (Optional) String See Segment API identifier . Segment ID indicating the analytics-enabled segment for which event analytics should be returned. Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportCustomEvents.html#events_data_series_get/2","title":"BrazeEx.Api.ExportCustomEvents.events_data_series_get/2","type":"function"},{"doc":"Custom Events List Use this endpoint to export a list of custom events that have been recorded for your app. The event names are returned in groups of 250, sorted alphabetically. Rate limit For customers who onboarded with Braze on or after September 16, 2021, we apply a shared rate limit of 1,000 requests per hour to this endpoint. This rate limit is shared with the /purchases/product_list endpoint, as documented in API rate limits . Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;message&quot;: (required, string) the status of the export, returns 'success' when completed without errors, &quot;events&quot; : [ &quot;Event A&quot;, &quot;Event B&quot;, &quot;Event C&quot;, ... ] } Fatal error response codes The following status codes and associated error messages will be returned if your request encounters a fatal error. Any of these error codes indicate that no data will be processed. Error Code Reason / Cause 400 Bad Request Bad Syntax 401 Unauthorized Unknown or missing REST API Key 429 Rate Limited Over rate limit 5XX Internal server error, you should retry with exponential backoff Tip: For help with CSV and API exports, visit Export troubleshooting . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :page (integer()): (Optional) Integer The page of event names to return, defaults to 0 (returns the first set of up to 250). Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportCustomEvents.html#events_list_get/2","title":"BrazeEx.Api.ExportCustomEvents.events_list_get/2","type":"function"},{"doc":"API calls for all endpoints tagged ExportKPI .","ref":"BrazeEx.Api.ExportKPI.html","title":"BrazeEx.Api.ExportKPI","type":"module"},{"doc":"Daily Active Users by Date Use this endpoint to retrieve a daily series of the total number of unique active users on each date. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;message&quot;: (required, string) the status of the export, returns 'success' when completed without errors, &quot;data&quot; : [ { &quot;time&quot; : (string) date as ISO 8601 date, &quot;dau&quot; : (int) }, ... ] } Tip: For help with CSV and API exports, visit Export troubleshooting . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :length (integer()): (Required) Integer Maximum number of days before ending_at to include in the returned series. Must be between 1 and 100 (inclusive). :ending_at (String.t): (Optional) Datetime ( ISO 8601 string) Date on which the data series should end. Defaults to time of the request. :app_id (String.t): (Optional) String App API identifier retrieved from the Developer Console . if excluded, results for all apps in app group will be returned. Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportKPI.html#kpi_dau_data_series_get/2","title":"BrazeEx.Api.ExportKPI.kpi_dau_data_series_get/2","type":"function"},{"doc":"Monthly Active Users for Last 30 Days Use this endpoint to retrieve a daily series of the total number of unique active users over a 30-day rolling window. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;message&quot;: (required, string) the status of the export, returns 'success' when completed without errors, &quot;data&quot; : [ { &quot;time&quot; : (string) date as ISO 8601 date, &quot;mau&quot; : (int) }, ... ] } Tip: For help with CSV and API exports, visit Export troubleshooting . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :length (integer()): (Required) Integer Maximum number of days before ending_at to include in the returned series. Must be between 1 and 100 (inclusive). :ending_at (String.t): (Optional) Datetime ( ISO 8601 string) Date on which the data series should end. Defaults to time of the request. :app_id (String.t): (Optional) String App API identifier retrieved from the Developer Console . if excluded, results for all apps in app group will be returned. Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportKPI.html#kpi_mau_data_series_get/2","title":"BrazeEx.Api.ExportKPI.kpi_mau_data_series_get/2","type":"function"},{"doc":"Daily New Users by Date Use this endpoint to retrieve a daily series of the total number of new users on each date. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;message&quot;: (required, string) the status of the export, returns 'success' when completed without errors, &quot;data&quot; : [ { &quot;time&quot; : (string) date as ISO 8601 date, &quot;new_users&quot; : (int) }, ... ] } Tip: For help with CSV and API exports, visit Export troubleshooting . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :length (integer()): (Required) Integer Maximum number of days before ending_at to include in the returned series. Must be between 1 and 100 (inclusive). :ending_at (String.t): (Optional) Datetime ( ISO 8601 string) Date on which the data series should end. Defaults to time of the request. :app_id (String.t): (Optional) String App API identifier retrieved from the Developer Console . if excluded, results for all apps in app group will be returned. Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportKPI.html#kpi_new_users_data_series_get/2","title":"BrazeEx.Api.ExportKPI.kpi_new_users_data_series_get/2","type":"function"},{"doc":"KPIs for Daily App Uninstalls by Date Use this endpoint to retrieve a daily series of the total number of uninstalls on each date. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;message&quot;: (required, string) the status of the export, returns 'success' when completed without errors, &quot;data&quot; : [ { &quot;time&quot; : (string) date as ISO 8601 date, &quot;uninstalls&quot; : (int) }, ... ] } Tip: For help with CSV and API exports, visit Export troubleshooting . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :length (integer()): (Required) Integer Maximum number of days before ending_at to include in the returned series. Must be between 1 and 100 (inclusive). :ending_at (String.t): (Optional) Datetime ( ISO 8601 string) Date on which the data series should end. Defaults to time of the request. :app_id (String.t): (Optional) String App API identifier retrieved from the Developer Console . if excluded, results for all apps in app group will be returned. Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportKPI.html#kpi_uninstalls_data_series_get/2","title":"BrazeEx.Api.ExportKPI.kpi_uninstalls_data_series_get/2","type":"function"},{"doc":"API calls for all endpoints tagged ExportNewsFeed .","ref":"BrazeEx.Api.ExportNewsFeed.html","title":"BrazeEx.Api.ExportNewsFeed","type":"module"},{"doc":"News Feed Card Analytics Use this endpoint to retrieve a daily series of engagement stats for a card over time. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;message&quot;: (required, string) the status of the export, returns 'success' when completed without errors, &quot;data&quot; : [ { &quot;time&quot; : (string) point in time - as ISO 8601 extended when unit is &quot;hour&quot; and as ISO 8601 date when unit is &quot;day&quot;, &quot;clicks&quot; : (int) , &quot;impressions&quot; : (int), &quot;unique_clicks&quot; : (int), &quot;unique_impressions&quot; : (int) }, ... ] } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :card_id (String.t): (Required) String See Card API identifier . The card_id for a given card can be found in the Developer Console page and on the card details page within your dashboard, or you can use the News Feed List Endpoint . :length (integer()): (Required) Integer Max number of units (days or hours) before ending_at to include in the returned series. Must be between 1 and 100 (inclusive). :unit (String.t): (Optional) String Unit of time between data points. Can be day or hour , defaults to day . :ending_at (String.t): (Optional) Datetime ( ISO 8601 string) Date on which the data series should end. Defaults to time of the request. Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportNewsFeed.html#feed_data_series_get/2","title":"BrazeEx.Api.ExportNewsFeed.feed_data_series_get/2","type":"function"},{"doc":"News Feed Cards Details Use this endpoint to retrieve relevant information on a card, which can be identified by the  card_id . Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;message&quot;: (required, string) The status of the export, returns 'success' when completed without errors, &quot;created_at&quot; : (string) Date created as ISO 8601 date, &quot;updated_at&quot; : (string) Date last updated as ISO 8601 date, &quot;name&quot; : (string) Card name, &quot;publish_at&quot; : (string) Date card was published as ISO 8601 date, &quot;end_at&quot; : (string) Date card will stop displaying for users as ISO 8601 date, &quot;tags&quot; : (array) Tag names associated with the card, &quot;title&quot; : (string) Title of the card, &quot;image_url&quot; : (string) Image URL used by this card, &quot;extras&quot; : (dictionary) Dictionary containing key-value pair data attached to this card, &quot;description&quot; : (string) Description text used by this card, &quot;archived&quot;: (boolean) whether this Card is archived, &quot;draft&quot;: (boolean) whether this Card is a draft, } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :card_id (String.t): (Required) String See Card API identifier . The card_id for a given card can be found in the Developer Console page and on the card details page within your dashboard, or you can use the News Feed List Endpoint . Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportNewsFeed.html#feed_details_get/2","title":"BrazeEx.Api.ExportNewsFeed.feed_details_get/2","type":"function"},{"doc":"News Feed Cards List Use this endpoint to export a list of News Feed cards, each of which will include its name and card API identifier. The cards are returned in groups of 100 sorted by time of creation (oldest to newest by default). Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;message&quot;: (required, string) the status of the export, returns 'success' when completed without errors, &quot;cards&quot; : [ { &quot;id&quot; : (string) Card API Identifier, &quot;type&quot; : (string) type of the card - NewsItem (classic cards), CaptionedImage, Banner or DevPick (cross-promotional cards), &quot;title&quot; : (string) title of the card, &quot;tags&quot; : (array) tag names associated with the card }, ... ] } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :page (integer()): (Optional) Integer The page of cards to return, defaults to 0 (returns the first set of up to 100). :include_archived (boolean()): (Optional) Boolean Whether or not to include archived cards, defaults to false. :sort_direction (String.t): (Optional) String - Sort creation time from newest to oldest: pass in the value desc . - Sort creation time from oldest to newest: pass in the value asc . If sort_direction is not included, the default order is oldest to newest. Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportNewsFeed.html#feed_list_get/2","title":"BrazeEx.Api.ExportNewsFeed.feed_list_get/2","type":"function"},{"doc":"API calls for all endpoints tagged ExportPurchases .","ref":"BrazeEx.Api.ExportPurchases.html","title":"BrazeEx.Api.ExportPurchases","type":"module"},{"doc":"Product IDs List Use this endpoint to return a paginated lists of product IDs. Rate limit For customers who onboarded with Braze on or after September 16, 2021, we apply a shared rate limit of 1,000 requests per hour to this endpoint. This rate limit is shared with the /events/list endpoint, as documented in API rate limits . Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;products&quot;: [ &quot;5499334426779&quot;, &quot;5499334819995&quot;, &quot;5499335442587&quot;, &quot;5499335835803&quot;, &quot;Calendula Face Mask Peel&quot;, &quot;Dior Lip Gloss&quot;, &quot;Rice Bowl&quot;, &quot;product_name&quot; ], &quot;message&quot;: &quot;success&quot; } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :page (integer()): (Optional) Integer The page of your product list that you would like to view. Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportPurchases.html#purchases_product_list_get/2","title":"BrazeEx.Api.ExportPurchases.purchases_product_list_get/2","type":"function"},{"doc":"API calls for all endpoints tagged ExportSegment .","ref":"BrazeEx.Api.ExportSegment.html","title":"BrazeEx.Api.ExportSegment","type":"module"},{"doc":"Segment Analytics Use this endpoint to retrieve a daily series of the estimated size of a segment over time. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;message&quot;: (required, string) the status of the export, returns 'success' when completed without errors, &quot;data&quot; : [ { &quot;time&quot; : (string) date as ISO 8601 date, &quot;size&quot; : (int) size of the segment on that date }, ... ] } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :segment_id (String.t): (Required) String See Segment API identifier . The segment_id for a given segment can be found in your Developer Console within your Braze account or you can use the Segment List Endpoint . :length (integer()): (Required) Integer Max number of days before ending_at to include in the returned series - must be between 1 and 100 (inclusive). :ending_at (String.t): (Optional) Datetime ( ISO 8601 string) Date on which the data series should end. Defaults to time of the request. Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportSegment.html#segments_data_series_get/2","title":"BrazeEx.Api.ExportSegment.segments_data_series_get/2","type":"function"},{"doc":"Segment Details Use this endpoint to retrieve relevant information on a segment, which can be identified by the  segment_id . Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;message&quot;: (required, string) the status of the export, returns 'success' when completed without errors, &quot;created_at&quot; : (string) date created as ISO 8601 date, &quot;updated_at&quot; : (string) date last updated as ISO 8601 date, &quot;name&quot; : (string) segment name, &quot;description&quot; : (string) human-readable description of filters, &quot;text_description&quot; : (string) segment description, &quot;tags&quot; : (array) tag names associated with the segment } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :segment_id (String.t): (Required) String See Segment API identifier . The segment_id for a given segment can be found in your Developer Console within your Braze account or you can use the Segment List Endpoint . Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportSegment.html#segments_details_get/2","title":"BrazeEx.Api.ExportSegment.segments_details_get/2","type":"function"},{"doc":"Segment List Use this endpoint to export a list of segments, each of which will include its name, Segment API identifier, and whether it has analytics tracking enabled. The segments are returned in groups of 100 sorted by time of creation (oldest to newest by default). Archived segments are not included. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;message&quot;: (required, string) the status of the export, returns 'success' when completed without errors, &quot;segments&quot; : [ { &quot;id&quot; : (string) Segment API Identifier, &quot;name&quot; : (string) segment name, &quot;analytics_tracking_enabled&quot; : (boolean) whether the segment has analytics tracking enabled, &quot;tags&quot; : (array) tag names associated with the segment }, ... ] } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :page (integer()): (Optional) Integer The page of segments to return, defaults to 0 (returns the first set of up to 100). :sort_direction (String.t): (Optional) String - Sort creation time from newest to oldest: pass in the value desc . - Sort creation time from oldest to newest: pass in the value asc . If sort_direction is not included, the default order is oldest to newest. Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportSegment.html#segments_list_get/2","title":"BrazeEx.Api.ExportSegment.segments_list_get/2","type":"function"},{"doc":"API calls for all endpoints tagged ExportSessionAnalytics .","ref":"BrazeEx.Api.ExportSessionAnalytics.html","title":"BrazeEx.Api.ExportSessionAnalytics","type":"module"},{"doc":"App Sessions by Time Use this endpoint to retrieve a series of the number of sessions for your app over a designated time period. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;message&quot;: (required, string) the status of the export, returns 'success' when completed without errors, &quot;data&quot; : [ { &quot;time&quot; : (string) point in time - as ISO 8601 extended when unit is &quot;hour&quot; and as ISO 8601 date when unit is &quot;day&quot;, &quot;sessions&quot; : (int) }, ... ] } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :length (integer()): (Required) Integer Max number of days before ending_at to include in the returned series - must be between 1 and 100 (inclusive). :unit (String.t): (Optional) String Unit of time between data points. Can be day or hour , defaults to day . :ending_at (String.t): (Optional) Datetime ( ISO 8601 string) Date on which the data series should end. Defaults to time of the request. :app_id (String.t): (Optional) String App API identifier retrieved from the Developer Console to limit analytics to a specific app. :segment_id (String.t): (Required) String See Segment API identifier . The segment_id for a given segment can be found in your Developer Console within your Braze account or you can use the Segment List Endpoint . Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportSessionAnalytics.html#sessions_data_series_get/2","title":"BrazeEx.Api.ExportSessionAnalytics.sessions_data_series_get/2","type":"function"},{"doc":"API calls for all endpoints tagged ExportUsers .","ref":"BrazeEx.Api.ExportUsers.html","title":"BrazeEx.Api.ExportUsers","type":"module"},{"doc":"User Profile Export by Global Control Group Use this endpoint to export all users within a Global Control Group. User data is exported as multiple files of user JSON objects separated by new lines (i.e., one JSON object per line). Warning: Individual custom attributes cannot be exported. However, all custom attributes can be exported by including custom_attributes in the fields_to_export array (e.g.,[‘first_name’, ‘email’, ‘custom_attributes’]). Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Credential-based response details For information regarding credentials-based response details, visit this section in the Braze API docs. Request parameters Parameter Required Data Type Description callback_endpoint Optional String Endpoint to post a download URL to when the export is available. fields_to_export Required* Array of strings Name of user data fields to export, you may also export custom attributes. &lt;br&gt; &lt;br&gt;*Beginning April 2021, new accounts must specify specific fields to export. output_format Optional String When using your own S3 bucket, allows to specify file format as zip or gzip . Defaults to ZIP file format. Fields to export The following is a list of valid fields_to_export. Using fields_to_export to minimize the data returned can improve response time of this API endpoint: apps attributed_campaign attributed_source attributed_adgroup attributed_ad braze_id country created_at custom_attributes custom_events devices dob email external_id first_name gender home_city language last_coordinates last_name phone purchases random_bucket time_zone total_revenue uninstalled_at user_aliases Response Content - Type : application / json Authorization : Bearer YOUR - REST - API - KEY { &quot;message&quot; : ( required , string ) the status of the export , returns &#39;success&#39; when completed without errors , &quot;object_prefix&quot; : ( required , string ) the filename prefix that will be used for the JSON file produced by this export , e . g . , &#39;bb8e2a91-c4aa-478b-b3f2-a4ee91731ad1-1464728599&#39; , &quot;url&quot; : ( optional , string ) the URL where the segment export data can be downloaded if you do not have your own S3 credentials } Once made available, the URL will only be valid for a few hours. As such, we highly recommend that you add your own S3 credentials to Braze. Sample user export file output User export object (we will include the least data possible - if a field is missing from the object it should be assumed to be null, false, or empty): { &quot;external_id&quot; : ( string ) , &quot;user_aliases&quot; : [ { &quot;alias_name&quot; : ( string ) , &quot;alias_label&quot; : ( string ) } ] , &quot;braze_id&quot; : ( string ) , &quot;first_name&quot; : ( string ) , &quot;last_name&quot; : ( string ) , &quot;email&quot; : ( string ) , &quot;dob&quot; : ( string ) date for the user &#39; s date of birth , &quot;home_city&quot; : ( string ) , &quot;country&quot; : ( string ) , &quot;phone&quot; : ( string ) , &quot;language&quot; : ( string ) ISO - 639 two letter code , &quot;time_zone&quot; : ( string ) , &quot;last_coordinates&quot; : ( array of float ) [ lon , lat ] , &quot;gender&quot; : ( string ) &quot;M&quot; | &quot;F&quot; , &quot;total_revenue&quot; : ( float ) , &quot;attributed_campaign&quot; : ( string ) , &quot;attributed_source&quot; : ( string ) , &quot;attributed_adgroup&quot; : ( string ) , &quot;attributed_ad&quot; : ( string ) , &quot;custom_attributes&quot; : ( object ) custom attribute key - value pairs , &quot;custom_events&quot; : [ { &quot;name&quot; : ( string ) , &quot;first&quot; : ( string ) date , &quot;last&quot; : ( string ) date , &quot;count&quot; : ( int ) } , ... ] , &quot;purchases&quot; : [ { &quot;name&quot; : ( string ) , &quot;first&quot; : ( string ) date , &quot;last&quot; : ( string ) date , &quot;count&quot; : ( int ) } , ... ] , &quot;devices&quot; : [ { &quot;model&quot; : ( string ) , &quot;os&quot; : ( string ) , &quot;carrier&quot; : ( string ) , &quot;idfv&quot; : ( string ) only included for iOS devices , &quot;idfa&quot; : ( string ) only included for iOS devices when IDFA collection is enabled , &quot;google_ad_id&quot; : ( string ) only included for Android devices when Google Play Advertising Identifier collection is enabled , &quot;roku_ad_id&quot; : ( string ) only included for Roku devices , &quot;windows_ad_id&quot; : ( string ) only included for Windows devices , &quot;ad_tracking_enabled&quot; : ( bool ) } , ... ] , &quot;apps&quot; : [ { &quot;name&quot; : ( string ) , &quot;platform&quot; : ( string ) , &quot;version&quot; : ( string ) , &quot;sessions&quot; : ( string ) , &quot;first_used&quot; : ( string ) date , &quot;last_used&quot; : ( string ) date } , ... ] , } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportUsers.html#users_export_global_control_group_post/2","title":"BrazeEx.Api.ExportUsers.users_export_global_control_group_post/2","type":"function"},{"doc":"User Profile Export by Identifier Use this endpoint to export data from any user profile by specifying a user identifier. Up to 50  external_ids  or  user_aliases  can be included in a single request. Should you want to specify  device_id  or  email_address  only one of either identifier can be included per request. Rate limit We apply a rate limit of 2,500 requests per minute to this endpoint, as documented in API rate limits . Request parameters Parameter Required Data Type Description external_ids Optional Array of strings External identifiers for users you wish export. user_aliases Optional Array of user alias object User aliases for users to export. device_id Optional String Device identifier, as returned by various SDK methods such as getDeviceId . braze_id Optional String Braze identifier for a particular user. email_address Optional String Email address of user. phone Optional String in E.164 format Phone number of user. fields_to_export Optional Array of strings Name of user data fields to export. Defaults to all if not provided. Fields to export The following is a list of valid fields_to_export . Using fields_to_export to minimize the data returned can improve response time of this API endpoint: apps attributed_campaign attributed_source attributed_adgroup attributed_ad braze_id campaigns_received canvases_received cards_clicked country created_at custom_attributes custom_events devices dob email email_subscribe external_id first_name gender home_city language last_coordinates last_name phone purchases push_subscribe push_tokens random_bucket time_zone total_revenue uninstalled_at user_aliases Be aware that the /users/export/ids endpoint will pull together the entire user profile for this user, including data such as all campaigns and Canvases received, all custom events performed, all purchases made, and all custom attributes. As a result, this endpoint is slower than other REST API endpoints. Depending on the data requested, this API endpoint may not be sufficient to meet your needs due to the 2,500 requests per minute rate limit. If you anticipate using this endpoint regularly to export users, instead consider exporting users by segment, which is asynchronous and more optimized for larger data pulls. Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;message&quot;: (required, string) the status of the export, returns 'success' when completed without errors, &quot;users&quot; : (array of object) the data for each of the exported users, may be empty if no users are found, &quot;invalid_user_ids&quot; : (optional, array of string) each of the identifiers provided in the request that did not correspond to a known user } For an example of the data that is accessible via this endpoint see the following example. Sample user export file output User export object (we will include the least data possible - if a field is missing from the object it should be assumed to be null, false, or empty): { &quot;external_id&quot; : (string), &quot;user_aliases&quot; : [ { &quot;alias_name&quot; : (string), &quot;alias_label&quot; : (string) } ], &quot;braze_id&quot;: (string), &quot;first_name&quot; : (string), &quot;last_name&quot; : (string), &quot;email&quot; : (string), &quot;dob&quot; : (string) date for the user's date of birth, &quot;home_city&quot; : (string), &quot;country&quot; : (string), &quot;phone&quot; : (string), &quot;language&quot; : (string) ISO-639 two letter code, &quot;time_zone&quot; : (string), &quot;last_coordinates&quot; : (array of float) [lon, lat], &quot;gender&quot; : (string) &quot;M&quot; | &quot;F&quot;, &quot;total_revenue&quot; : (float), &quot;attributed_campaign&quot; : (string), &quot;attributed_source&quot; : (string), &quot;attributed_adgroup&quot; : (string), &quot;attributed_ad&quot; : (string), &quot;push_subscribe&quot; : (string) &quot;opted_in&quot; | &quot;subscribed&quot; | &quot;unsubscribed&quot;, &quot;email_subscribe&quot; : (string) &quot;opted_in&quot; | &quot;subscribed&quot; | &quot;unsubscribed&quot;, &quot;custom_attributes&quot; : (object) custom attribute key-value pairs, &quot;custom_events&quot; : [ { &quot;name&quot; : (string), &quot;first&quot; : (string) date, &quot;last&quot; : (string) date, &quot;count&quot; : (int) }, ... ], &quot;purchases&quot; : [ { &quot;name&quot; : (string), &quot;first&quot; : (string) date, &quot;last&quot; : (string) date, &quot;count&quot; : (int) }, ... ], &quot;devices&quot; : [ { &quot;model&quot; : (string), &quot;os&quot; : (string), &quot;carrier&quot; : (string), &quot;idfv&quot; : (string) only included for iOS devices, &quot;idfa&quot; : (string) only included for iOS devices when IDFA collection is enabled, &quot;google_ad_id&quot; : (string) only included for Android devices when Google Play Advertising Identifier collection is enabled, &quot;roku_ad_id&quot; : (string) only included for Roku devices, &quot;windows_ad_id&quot; : (string) only included for Windows devices, &quot;ad_tracking_enabled&quot; : (bool) }, ... ], &quot;push_tokens&quot; : [ { &quot;app&quot; : (string) app name, &quot;platform&quot; : (string), &quot;token&quot; : (string) }, ... ], &quot;apps&quot; : [ { &quot;name&quot; : (string), &quot;platform&quot; : (string), &quot;version&quot; : (string), &quot;sessions&quot; : (integer), &quot;first_used&quot; : (string) date, &quot;last_used&quot; : (string) date }, ... ], &quot;campaigns_received&quot; : [ { &quot;name&quot; : (string), &quot;last_received&quot; : (string) date, &quot;engaged&quot; : { &quot;opened_email&quot; : (bool), &quot;opened_push&quot; : (bool), &quot;clicked_email&quot; : (bool), &quot;clicked_triggered_in_app_message&quot; : (bool) }, &quot;converted&quot; : (bool), &quot;api_campaign_id&quot; : (string), &quot;variation_name&quot; : (optional, string) exists only if it is a multivariate campaign, &quot;variation_api_id&quot; : (optional, string) exists only if it is a multivariate campaign, &quot;in_control&quot; : (optional, bool) exists only if it is a multivariate campaign }, ... ], &quot;canvases_received&quot;: [ { &quot;name&quot;: (string), &quot;api_canvas_id&quot;: (string), &quot;last_received_message&quot;: (string) date, &quot;last_entered&quot;: (string) date, &quot;variation_name&quot;: (string), &quot;in_control&quot;: (bool), &quot;last_exited&quot;: (string) date, &quot;steps_received&quot;: [ { &quot;name&quot;: (string), &quot;api_canvas_step_id&quot;: (string), &quot;last_received&quot;: (string) date }, { &quot;name&quot;: (string), &quot;api_canvas_step_id&quot;: (string), &quot;last_received&quot;: (string) date }, { &quot;name&quot;: (string), &quot;api_canvas_step_id&quot;: (string), &quot;last_received&quot;: (string) date } ] }, ... ], &quot;cards_clicked&quot; : [ { &quot;name&quot; : (string) }, ... ] } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportUsers.html#users_export_ids_post/2","title":"BrazeEx.Api.ExportUsers.users_export_ids_post/2","type":"function"},{"doc":"User Profile Export by Segment Use this endpoint to export all the users within a segment. User data is exported as multiple files of user JSON objects separated by new lines (i.e., one JSON object per line). Data is exported to an automatically generated URL, or to an S3 bucket if this integration is already set up. This endpoint is currently not supported by Google Cloud Storage. Note that a company may run at most one export per segment using this endpoint at a given time. Wait for your export to complete before retrying. Beginning December 2021, the following changed for this API: The fields_to_export field in this API request is required. The option to default to all fields has been removed. The fields for custom_events, purchases, campaigns_received, and canvases_received only contain data from the last 90 days. Warning: Individual custom attributes cannot be exported. However, all custom attributes can be exported by including custom_attributes in the fields_to_export array (e.g., [‘first_name’, ‘email’, ‘custom_attributes’]). Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Credential-based response details For information regarding credentials-based response details, visit this section in the Braze API docs. Request parameters Parameter Required Data Type Description segment_id Required String Identifier for the segment to be exported. See segment identifier . &lt;br&gt; &lt;br&gt;The segment_id for a given segment can be found in your Developer Console within your Braze account or you can use the Segment List Endpoint . callback_endpoint Optional String Endpoint to post a download URL to when the export is available. fields_to_export Required* Array of strings Name of user data fields to export, you may also export custom attributes. &lt;br&gt; &lt;br&gt;*Beginning April 2021, new accounts must specify specific fields to export. output_format Optional String When using your own S3 bucket, allows you to specify file format as zip or gzip . Defaults to ZIP file format. Fields to export The following is a list of valid fields_to_export . Using fields_to_export to minimize the data returned can improve response time of this API endpoint: apps attributed_campaign attributed_source attributed_adgroup attributed_ad braze_id campaigns_received canvases_received cards_clicked country created_at custom_attributes custom_events devices dob email email_subscribe external_id first_name gender home_city language last_coordinates last_name phone purchases push_subscribe push_tokens random_bucket time_zone total_revenue uninstalled_at user_aliases Important reminders The fields for custom_events , purchases , campaigns_received , and canvases_received will contain only contain data from the last 90 days. Both custom_events and purchases contain fields for first and count . Both of these fields will reflect information from all time, and will not be limited to just data from the last 90 days. For example, if a particular user first did the event prior to 90 days ago, this will be accurately reflected in the first field, and the count field will take into account events that occurred prior to the last 90 days as well. The number of concurrent segment exports a company can run at the endpoint level is capped at 100. Attempts that surpass this limit will result in an error. Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;message&quot;: (required, string) the status of the export, returns 'success' when completed without errors, &quot;object_prefix&quot;: (required, string) the filename prefix that will be used for the JSON file produced by this export, e.g. 'bb8e2a91-c4aa-478b-b3f2-a4ee91731ad1-1464728599', &quot;url&quot; : (optional, string) the URL where the segment export data can be downloaded if you do not have your own S3 credentials } Once made available, the URL will only be valid for a few hours. As such, we highly recommend that you add your own S3 credentials to Braze. Sample user export file output User export object (we will include the least data possible - if a field is missing from the object it should be assumed to be null, false, or empty): { &quot;external_id&quot; : (string), &quot;user_aliases&quot; : [ { &quot;alias_name&quot; : (string), &quot;alias_label&quot; : (string) } ], &quot;braze_id&quot;: (string), &quot;first_name&quot; : (string), &quot;last_name&quot; : (string), &quot;email&quot; : (string), &quot;dob&quot; : (string) date for the user's date of birth, &quot;home_city&quot; : (string), &quot;country&quot; : (string), &quot;phone&quot; : (string), &quot;language&quot; : (string) ISO-639 two letter code, &quot;time_zone&quot; : (string), &quot;last_coordinates&quot; : (array of float) [lon, lat], &quot;gender&quot; : (string) &quot;M&quot; | &quot;F&quot;, &quot;total_revenue&quot; : (float), &quot;attributed_campaign&quot; : (string), &quot;attributed_source&quot; : (string), &quot;attributed_adgroup&quot; : (string), &quot;attributed_ad&quot; : (string), &quot;push_subscribe&quot; : (string) &quot;opted_in&quot; | &quot;subscribed&quot; | &quot;unsubscribed&quot;, &quot;email_subscribe&quot; : (string) &quot;opted_in&quot; | &quot;subscribed&quot; | &quot;unsubscribed&quot;, &quot;custom_attributes&quot; : (object) custom attribute key value pairs, &quot;custom_events&quot; : [ { &quot;name&quot; : (string), &quot;first&quot; : (string) date, &quot;last&quot; : (string) date, &quot;count&quot; : (int) }, ... ], &quot;purchases&quot; : [ { &quot;name&quot; : (string), &quot;first&quot; : (string) date, &quot;last&quot; : (string) date, &quot;count&quot; : (int) }, ... ], &quot;devices&quot; : [ { &quot;model&quot; : (string), &quot;os&quot; : (string), &quot;carrier&quot; : (string), &quot;idfv&quot; : (string) only included for iOS devices, &quot;idfa&quot; : (string) only included for iOS devices when IDFA collection is enabled, &quot;google_ad_id&quot; : (string) only included for Android devices when Google Play Advertising Identifier collection is enabled, &quot;roku_ad_id&quot; : (string) only included for Roku devices, &quot;windows_ad_id&quot; : (string) only included for Windows devices, &quot;ad_tracking_enabled&quot; : (bool) }, ... ], &quot;push_tokens&quot; : [ { &quot;app&quot; : (string) app name, &quot;platform&quot; : (string), &quot;token&quot; : (string) }, ... ], &quot;apps&quot; : [ { &quot;name&quot; : (string), &quot;platform&quot; : (string), &quot;version&quot; : (string), &quot;sessions&quot; : (string), &quot;first_used&quot; : (string) date, &quot;last_used&quot; : (string) date }, ... ], &quot;campaigns_received&quot; : [ { &quot;name&quot; : (string), &quot;last_received&quot; : (string) date, &quot;engaged&quot; : { &quot;opened_email&quot; : (bool), &quot;opened_push&quot; : (bool), &quot;clicked_email&quot; : (bool), &quot;clicked_in_app_message&quot; : (bool) }, &quot;converted&quot; : (bool), &quot;api_campaign_id&quot; : (string), &quot;variation_name&quot; : (optional, string) exists only if it is a multivariate campaign, &quot;variation_api_id&quot; : (optional, string) exists only if it is a multivariate campaign, &quot;in_control&quot; : (optional, bool) exists only if it is a multivariate campaign }, ... ], &quot;canvases_received&quot;: [ { &quot;name&quot;: (string), &quot;api_canvas_id&quot;: (string), &quot;last_received_message&quot;: (string) date, &quot;last_entered&quot;: (string) date, &quot;variation_name&quot;: (string), &quot;in_control&quot;: (bool), &quot;last_exited&quot;: (string) date, &quot;steps_received&quot;: [ { &quot;name&quot;: (string), &quot;api_canvas_step_id&quot;: (string), &quot;last_received&quot;: (string) date }, { &quot;name&quot;: (string), &quot;api_canvas_step_id&quot;: (string), &quot;last_received&quot;: (string) date }, { &quot;name&quot;: (string), &quot;api_canvas_step_id&quot;: (string), &quot;last_received&quot;: (string) date } ] }, ... ], &quot;cards_clicked&quot; : [ { &quot;name&quot; : (string) }, ... ] } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.ExportUsers.html#users_export_segment_post/2","title":"BrazeEx.Api.ExportUsers.users_export_segment_post/2","type":"function"},{"doc":"API calls for all endpoints tagged MessagingScheduleMesages .","ref":"BrazeEx.Api.MessagingScheduleMesages.html","title":"BrazeEx.Api.MessagingScheduleMesages","type":"module"},{"doc":"Schedule API Triggered Campaigns Use this endpoint to send dashboard created campaign messages (up to 90 days in advance) via API-triggered delivery, allowing you to decide what action should trigger the message to be sent. You can pass in  trigger_properties  that will be templated into the message itself. Note that to send messages with this endpoint, you must have a Campaign ID, created when you build an  API-Triggered Campaign . Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Braze endpoints support batching API requests . A single request to the messaging endpoints can reach any of the following: Up to 50 specific external_ids, each with individual message parameters A segment of any size created in the Braze dashboard, specified by its segment_id An ad-hoc audience segment of any size, defined in the request as a Connected Audience object Request parameters Parameter Required Data Type Description campaign_id Required String See campaign identifier send_id Optional String See send identifier . recipients Optional Array of recipient objects See recipients object . audience Optional Connected audience object See connected audience . broadcast Optional Boolean See broadcast . This parameter defaults to false (as of August 31, 2017). &lt;br&gt; &lt;br&gt;If recipients is omitted, broadcast must be set to true. However, use caution when setting broadcast: true , as unintentionally setting this flag may cause you to send your message to a larger than expected audience. trigger_properties Optional Object Personalization key-value pairs for all users in this send. See trigger properties . schedule Required Schedule object See schedule object . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.MessagingScheduleMesages.html#campaigns_trigger_schedule_create_post/2","title":"BrazeEx.Api.MessagingScheduleMesages.campaigns_trigger_schedule_create_post/2","type":"function"},{"doc":"Delete Scheduled API Triggered Campaigns The delete schedule endpoint allows you to cancel a message that you previously scheduled API-triggered Canvases before it has been sent. Scheduled messages or triggers that are deleted very close to or during the time they were supposed to be sent will be updated with best efforts, so last-second deletions could be applied to all, some, or none of your targeted users. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Request parameters Parameter Required Data Type Description campaign_id Required String See campaign identifier . schedule_id Required String The schedule_id to delete (obtained from the response to create schedule). Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.MessagingScheduleMesages.html#campaigns_trigger_schedule_delete_post/2","title":"BrazeEx.Api.MessagingScheduleMesages.campaigns_trigger_schedule_delete_post/2","type":"function"},{"doc":"Update Scheduled API Triggered Campaigns Use this endpoint to update scheduled API-triggered campaigns created in the dashboard, allowing you to decide what action should trigger the message to be sent. You can pass in  trigger_properties  that will be templated into the message itself. Note that to send messages with this endpoint, you must have a Campaign ID, created when you build an  API-Triggered Campaign . Any schedule will completely overwrite the one that you provided in the create schedule request or in previous update schedule requests. For example, if you originally provide &quot;schedule&quot; : {&quot;time&quot; : &quot;2015-02-20T13:14:47&quot;, &quot;in_local_time&quot; : true} and then in your update you provide &quot;schedule&quot; : {&quot;time&quot; : &quot;2015-02-20T14:14:47&quot;} , your message will now be sent at the provided time in UTC, not in the user's local time. Scheduled triggers that are updated very close to or during the time they were supposed to be sent will be updated with best efforts, so last-second changes could be applied to all, some, or none of your targeted users. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Request parameters Parameter Required Data Type Description campaign_id Required String See campaign identifier schedule_id Optional String The schedule_id to update (obtained from the response to create schedule). schedule Required Object See schedule object . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.MessagingScheduleMesages.html#campaigns_trigger_schedule_update_post/2","title":"BrazeEx.Api.MessagingScheduleMesages.campaigns_trigger_schedule_update_post/2","type":"function"},{"doc":"Schedule API Triggered Canvases Use this endpoint to schedule Canvas messages (up to 90 days in advance) via API-triggered delivery, allowing you to decide what action should trigger the message to be sent. You can pass in  canvas_entry_properties  that will be templated into the messages sent by the first steps of the Canvas. Note that to send messages with this endpoint, you must have a Canvas ID, created when you build a  Canvas . Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Braze endpoints support batching API requests . A single request to the messaging endpoints can reach any of the following: Up to 50 specific external_ids, each with individual message parameters A segment of any size created in the Braze dashboard, specified by its segment_id An ad-hoc audience segment of any size, defined in the request as a Connected Audience object Request parameters Parameter Required Data Type Description canvas_id Required String See Canvas identifier . send_id Optional String See send identifier . recipients Optional Array of recipient objects See recipients object . audience Optional Connected audience object See connected audience . broadcast Optional Boolean See broadcast . This parameter defaults to false (as of August 31, 2017). &lt;br&gt; &lt;br&gt;If recipients is omitted, broadcast must be set to true. However, use caution when setting broadcast: true , as unintentionally setting this flag may cause you to send your message to a larger than expected audience. trigger_properties Optional Object Personalization key-value pairs for all users in this send. See trigger properties . schedule Required Schedule object See schedule object . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.MessagingScheduleMesages.html#canvas_trigger_schedule_create_post/2","title":"BrazeEx.Api.MessagingScheduleMesages.canvas_trigger_schedule_create_post/2","type":"function"},{"doc":"Delete Scheduled API-Triggered Canvases Use this endpoint to cancel a Canvas message that you previously scheduled via API-triggered before it has been sent. Scheduled messages or triggers that are deleted very close to or during the time they were supposed to be sent will be updated with best efforts, so last-second deletions could be applied to all, some, or none of your targeted users. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Parameter Required Data Type Description canvas_id Required String See Canvas identifier . schedule_id Required String The schedule_id to delete (obtained from the response to create schedule). Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (map()): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.MessagingScheduleMesages.html#canvas_trigger_schedule_delete_post/2","title":"BrazeEx.Api.MessagingScheduleMesages.canvas_trigger_schedule_delete_post/2","type":"function"},{"doc":"Update Scheduled API Triggered Canvases Use this endpoint to update scheduled API-triggered Canvases that were created in the dashboard. This allows you to decide what action should trigger the message to be sent. You can pass in  trigger_properties  that will be templated into the message itself. Note that to send messages with this endpoint, you must have a Canvas ID, created when you build a  Canvas . Any schedule will completely overwrite the one that you provided in the create schedule request or in previous update schedule requests. For example, if you originally provide &quot;schedule&quot; : {&quot;time&quot; : &quot;2015-02-20T13:14:47&quot;, &quot;in_local_time&quot; : true} and then in your update you provide &quot;schedule&quot; : {&quot;time&quot; : &quot;2015-02-20T14:14:47&quot;} , your message will now be sent at the provided time in UTC, not in the user's local time. Scheduled triggers that are updated very close to or during the time they were supposed to be sent will be updated with best efforts, so last-second changes could be applied to all, some, or none of your targeted users. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Request parameters Parameter Required Data Type Description canvas_id Required String See Canvas identifier . schedule_id Optional String The schedule_id to update (obtained from the response to create schedule). schedule Required Object See schedule object . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.MessagingScheduleMesages.html#canvas_trigger_schedule_update_post/2","title":"BrazeEx.Api.MessagingScheduleMesages.canvas_trigger_schedule_update_post/2","type":"function"},{"doc":"Create Scheduled Messages Use this endpoint to schedule a campaign, Canvas, or other message to be sent at a designated time (up to 90 days in the future) and provides you with an identifier to reference that message for updates. If you are targeting a segment, a record of your request will be stored in the  Developer Console   after all scheduled messages have been sent. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Braze endpoints support batching API requests . A single request to the messaging endpoints can reach any of the following: Up to 50 specific external_ids, each with individual message parameters A segment of any size created in the Braze dashboard, specified by its segment_id An ad-hoc audience segment of any size, defined in the request as a Connected Audience object Request parameters Parameter Required Data Type Description broadcast Optional Boolean See broadcast . This parameter defaults to false (as of August 31, 2017). &lt;br&gt; &lt;br&gt;If recipients is omitted, broadcast must be set to true. However, use caution when setting broadcast: true , as unintentionally setting this flag may cause you to send your message to a larger than expected audience. external_user_ids Optional Array of strings See external user identifier . user_aliases Optional Array of user alias objects See user alias object . audience Optional Connected audience object See connected audience . segment_id Optional String See segment identifier . campaign_id Required String See campaign identifier . recipients Optional Array of recipients objects See recipients object . send_id Optional String See send identifier . override_messaging_limits Optional Boolean Ignore global rate limits for campaigns, defaults to false recipient_subscription_state Optional String Use this to send messages to only users who have opted in ( opted_in ), only users who have subscribed or are opted in ( subscribed ) or to all users, including unsubscribed users ( all ). &lt;br&gt; &lt;br&gt;Using all users is useful for transactional email messaging. Defaults to subscribed . schedule Required Schedule object See schedule object messages Optional Messaging object See available messaging objects . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :body (map()): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.MessagingScheduleMesages.html#messages_schedule_create_post/2","title":"BrazeEx.Api.MessagingScheduleMesages.messages_schedule_create_post/2","type":"function"},{"doc":"Delete Scheduled Messages Use this endpoint to cancel a message that you previously scheduled before it has been sent. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Request parameters Parameter Required Data Type Description schedule_id Required String The schedule_id to delete (obtained from the response to create schedule). Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.MessagingScheduleMesages.html#messages_schedule_delete_post/2","title":"BrazeEx.Api.MessagingScheduleMesages.messages_schedule_delete_post/2","type":"function"},{"doc":"Update Scheduled Messages Use this endpoint to update scheduled messages. This endpoint accepts updates to either the  schedule  or  messages  parameter or both. Your request must contain at least one of those two keys. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Request parameters Parameter Required Data Type Description schedule_id Required String The schedule_id to update (obtained from the response to create schedule). schedule Optional Object See schedule object . messages Optional Object See available message objects . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.MessagingScheduleMesages.html#messages_schedule_update_post/2","title":"BrazeEx.Api.MessagingScheduleMesages.messages_schedule_update_post/2","type":"function"},{"doc":"Get Upcoming Scheduled Campaigns and Canvases Use this endpoint to return a JSON list of information about scheduled campaigns and entry Canvases between now and a designated  end_time  specified in the request. Daily, recurring messages will only appear once with their next occurrence. Results returned in this endpoint are only for campaigns and Canvases created and scheduled in Braze. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;scheduled_broadcasts&quot;: [ # Example Canvas { &quot;name&quot; =&gt; String, &quot;id&quot; =&gt; String, &quot;type&quot; =&gt; &quot;Canvas&quot;, &quot;tags&quot; =&gt; [String tag names], &quot;next_send_time&quot; =&gt; &quot;YYYY-MM-DD HH:mm:ss&quot; (may also include time zone if not local/intelligent delivery) &quot;schedule_type&quot; =&gt; one of &quot;local_time_zones&quot;, &quot;intelligent_delivery&quot;, or the name of your company's time zone }, # Example Campaign { &quot;name&quot; =&gt; String, &quot;id&quot; =&gt; String, &quot;type&quot; =&gt; &quot;Campaign&quot;, &quot;tags&quot; =&gt; [String tag names], &quot;next_send_time&quot; =&gt; &quot;YYYY-MM-DD HH:mm:ss&quot; (may also include time zone if not local/intelligent delivery) &quot;schedule_type&quot; =&gt; one of &quot;local_time_zones&quot;, &quot;intelligent_delivery&quot;, or the name of your company's time zone }, ] } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :end_time (String.t): (Required) String in ISO 8601 format End date of the range to retrieve upcoming scheduled Campaigns and Canvases. This is treated as midnight in UTC time by the API. Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.MessagingScheduleMesages.html#messages_scheduled_broadcasts_get/2","title":"BrazeEx.Api.MessagingScheduleMesages.messages_scheduled_broadcasts_get/2","type":"function"},{"doc":"API calls for all endpoints tagged MessagingSendMessages .","ref":"BrazeEx.Api.MessagingSendMessages.html","title":"BrazeEx.Api.MessagingSendMessages","type":"module"},{"doc":"Sending Campaign Messages via API Triggered Delivery Use this endpoint to send immediate, ad-hoc messages to designated users via API-triggered delivery. API-triggered delivery allows you to house message content inside of the Braze dashboard while dictating when a message is sent, and to whom via your API. If you are targeting a segment, a record of your request will be stored in the  Developer Console  . Note that to send messages with this endpoint, you must have a Campaign ID created when you build an  API-triggered campaign . Rate limit When specifying a segment or Connected Audience in your request, we apply a rate limit of 250 requests per minute to this endpoint. Otherwise, if specifying an external_id , this endpoint has a default rate limit of 250,000 requests per hour, as documented in API rate limits . Braze endpoints support batching API requests . A single request to the messaging endpoints can reach any of the following: Up to 50 specific external_ids , each with individual message parameters A segment of any size created in the Braze dashboard, specified by its segment_id An ad-hoc audience segment of any size, defined in the request as a Connected Audience object Request parameters Parameter Required Data Type Description campaign_id Required String See campaign identifier . send_id Optional String See send identifier . trigger_properties Optional Object See trigger properties . Personalization key-value pairs that will apply to all users in this request. broadcast Optional Boolean See broadcast . This parameter defaults to false (as of August 31, 2017). &lt;br&gt; &lt;br&gt;If recipients is omitted, broadcast must be set to true. However, use caution when setting broadcast: true , as unintentionally setting this flag may cause you to send your campaign to a larger than expected audience. audience Optional Connected audience object See connected audience . recipients Optional Array See recipients object . If not provided and broadcast is set to true, the message will send to the entire segment targeted by the campaign. The recipients array may contain up to 50 objects, with each object containing a single external_user_id string and trigger_properties object. When send_to_existing_only is true , Braze will only send the message to existing users. When send_to_existing_only is false and a user with the given id does not exist, Braze will create a user with that id and attributes before sending the message. For more information on the &quot;broadcast&quot; flag, check out Broadcast within our API Parameters documentation. Response details Message sending endpoint responses will include the message’s dispatch_id for reference back to the dispatch of the message. The dispatch_id is the ID of the message dispatch, a unique ID for each transmission sent from the Braze platform. When using this endpoint, you receive a single dispatch_id for an entire batched set of users. For more information on dispatch_id check out out our documentation on Dispatch ID Behavior . Create send endpoint Using the attributes object in campaigns Braze has a Messaging Object called Attributes that will allow you to add, create, or update attributes and values for a user before you send them an API-triggered campaigns using the campaign/trigger/send endpoint as this API call will process the User Attributes object before it processes and sends the campaign. This helps minimize the risk of there being issues caused by race conditions . Important: Looking for the Canvas version of this endpoint? Check out Sending Canvas messages via API-triggered delivery . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.MessagingSendMessages.html#campaigns_trigger_send_post/2","title":"BrazeEx.Api.MessagingSendMessages.campaigns_trigger_send_post/2","type":"function"},{"doc":"Sending Canvas Messages via API Triggered Delivery Use this endpoint to send Canvas messages via API-triggered delivery. API-triggered Delivery allows you to house message content inside of the Braze dashboard while dictating when a message is sent, and to whom via your API. Note that to send messages with this endpoint, you must have a Canvas ID, created when you build a  Canvas . Rate limit When specifying a segment or Connected Audience in your request, we apply a rate limit of 250 requests per minute to this endpoint. Otherwise, if specifying an external_id , this endpoint has a default rate limit of 250,000 requests per hour, as documented in API rate limits . Braze endpoints support batching API requests . A single request to the messaging endpoints can reach any of the following: Up to 50 specific external_ids , each with individual message parameters A segment of any size created in the Braze dashboard, specified by its segment_id An ad-hoc audience segment of any size, defined in the request as a Connected Audience object Request parameters Parameter Required Data Type Description canvas_id Required String See Canvas identifier . canvas_entry_properties Optional Object See Canvas entry properties . Personalization key-value pairs that will apply to all users in this request. The Canvas entry properties object has a maximum size limit of 50 KB. broadcast Optional Boolean See Broadcast . This parameter defaults to false (as of August 31, 2017). &lt;br&gt; &lt;br&gt;If recipients is omitted, broadcast must be set to true. However, use caution when setting broadcast: true , as unintentionally setting this flag may cause you to send your Canvas to a larger than expected audience. audience Optional Connected audience object See Connected audience . recipients Optional Array See Recipients object . If not provided and broadcast is set to true, the message will send to the entire segment targeted by the Canvas. &lt;br&gt; &lt;br&gt;The recipients array may contain up to 50 objects, with each object containing a single external_user_id string and canvas_entry_properties object. Either external_user_id or user_alias is required for this call. Requests must specify only one. &lt;br&gt; &lt;br&gt;When send_to_existing_only is true, Braze will only send the message to existing users—however this flag can’t be used with user aliases. When send_to_existing_only is false and a user with the given id does not exist, Braze will create a user with that ID and attributes before sending the message. Customers using the API for server-to-server calls may need to whitelist the appropriate API URL if they’re behind a firewall. Note: If you include both specific users in your API call and a target segment in the dashboard, the message will send to specifically the user profiles that are in the API call and qualify for the segment filters. Response details Message sending endpoint responses will include the message’s dispatch_id for reference back to the dispatch of the message. The dispatch_id is the ID of the message dispatch (unique ID for each “transmission” sent from the Braze platform). Check out Dispatch ID behavior for more information. Create send endpoint Using the Attributes Object in Canvas Braze has a Messaging Object called Attributes that allows you to add, create, or update attributes and values for a user before sending them an API-Triggered Canvas using the canvas/trigger/send endpoint as this API call will process the User Attributes object before it processes and sends the Canvas. This helps minimize the risk of there being issues caused by race conditions . Important: Looking for the camaigns version of this endpoint? Check out Sending campaign messages via API-triggered delivery . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.MessagingSendMessages.html#canvas_trigger_send_post/2","title":"BrazeEx.Api.MessagingSendMessages.canvas_trigger_send_post/2","type":"function"},{"doc":"Sending Messages Immediately via API Only Use this endpoint to send immediate, ad-hoc messages to designated users via the Braze API. Be sure to include Messaging Objects in your body to complete your requests. If you are targeting a segment, a record of your request will be stored in the  Developer Console  . Rate limit When specifying a segment or Connected Audience in your request, we apply a rate limit of 250 requests per minute to this endpoint. Otherwise, if specifying an external_id , this endpoint has a default rate limit of 250,000 requests per hour, as documented in API rate limits . Braze endpoints support batching API requests . A single request to the messaging endpoints can reach any of the following: Up to 50 specific external_ids , each with individual message parameters A segment of any size created in the Braze dashboard, specified by its segment_id An ad-hoc audience segment of any size, defined in the request as a Connected Audience object Request parameters Parameter Required Data Type Description broadcast Optional Boolean See broadcast . This parameter defaults to false (as of August 31, 2017). &lt;br&gt; &lt;br&gt;If recipients is omitted, broadcast must be set to true. However, use caution when setting broadcast: true , as unintentionally setting this flag may cause you to send your messages to a larger than expected audience. external_user_ids Optional Array of strings See external user ID . user_aliases Optional Array of user alias objects See user alias object . segment_id Optional String See segment identifier . audience Optional Connected audience object See connected audience . campaign_id Optional* String See campaign identifier for more information. &lt;br&gt; &lt;br&gt;*Required if you wish to track campaign stats (e.g. sends, clicks, bounces, etc) on the Braze dashboard. send_id Optional String See send identifier override_frequency_capping Optional Boolean Ignore frequency_capping for campaigns, defaults to false. recipient_subscription_state Optional String Use this to send messages to only users who have opted in ( opted_in ), only users who have subscribed or are opted in ( subscribed ) or to all users, including unsubscribed users ( all ). &lt;br&gt; &lt;br&gt;Using all users is useful for transactional email messaging. Defaults to subscribed . messages Optional Messaging objects See available messaging objects . Response details Message sending endpoint responses will include the message’s dispatch_id for reference back to the dispatch of the message. The dispatch_id is the id of the message dispatch (unique id for each ‘transmission’ sent from the Braze platform). For more, information refer to Dispatch ID behavior . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.MessagingSendMessages.html#messages_send_post/2","title":"BrazeEx.Api.MessagingSendMessages.messages_send_post/2","type":"function"},{"doc":"Create Send IDs For Message Send Tracking Use this endpoint to create send IDs that can be used to send messages and track message performance programatically, without campaign creation for each send. Using the Send Identifier to track and send messages is useful if you are planning to programmatically generate and send content. Rate limit The daily maximum number of custom send identifiers that can be created via this endpoint is 100 for a given app group. Each send_id and campaign_id combination that you create will count towards your daily limit. The response headers for any valid request include the current rate limit status, see API rate limits for details. Request parameters Parameter Required Data Type Description campaign_id Required String See campaign identifier . send_id Optional String See send identifier . Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;message&quot;: &quot;success&quot;, &quot;send_id&quot; : &quot;example_send_id&quot; } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.MessagingSendMessages.html#sends_id_create_post/2","title":"BrazeEx.Api.MessagingSendMessages.sends_id_create_post/2","type":"function"},{"doc":"Sending Transactional Email via API Triggered Delivery Use this endpoint to send immediate, ad-hoc transactional messages to a designated user. This endpoint is used alongside the creation of a  Transactional Email campaign  and corresponding campaign ID. Important: Transactional Email is currently available as part of select Braze packages. Reach out to your Braze customer success manager for more details. Similar to the Send Triggered Campaign endpoint , this campaign type allows you to house message content inside of the Braze dashboard while dictating when and to whom a message is sent via your API. Unlike the Send Triggered Campaign endpoint, which accepts an audience or segment to send messages to, a request to this endpoint must specify a single user either by external_user_id or user_alias , as this campaign type is purpose-built for 1:1 messaging of alerts like order confirmations or password resets. Rate limit Transactional Emails are not subject to a rate limit. Depending on your chosen package, a set number of Transactional Emails is covered per hour by SLA. Requests that exceed that rate will still send, but are not covered by SLA. 99.9% of emails will send in less than one minute. Request Parameters Parameter Required Data Type Description external_send_id Optional String A Base64 compatible string. Validated against the following regex /^[a-zA-Z0-9-_+/=]+$/ . This optional field allows you to pass an internal identifier for this particular send which will be included in events sent from the Transactional HTTP event postback. When passed, this identifier will also be used as a deduplication key, which Braze will store for 24 hours. Passing the same identifier in another request will not result in a new instance of a send by Braze for 24 hours. trigger_properties Optional Object See trigger properties . Personalization key-value pairs that will apply to the user in this request. recipients Required Object The user you are targeting this message to. Can contain attributes and a single external_user_id or user_alias . &lt;br&gt; &lt;br&gt;Note that if you provide an external user ID that doesn’t already exist in Braze, passing any fields to the attributes object will create this user profile in Braze and send this message to the newly created user. &lt;br&gt; &lt;br&gt;If you send multiple requests to the same user with different data in the attributes object, Braze will ensure that first_name , last_name , and email attributes will be updated synchronously and templated into your message. Custom attributes don’t have this same protection, so proceed with caution when updating a user through this API and passing different custom attribute values in quick succession. Response The send transactional email endpoint will respond with the message’s dispatch_id which represents the instance of this message send. This identifier can be used along with events from the Transactional HTTP event postback to trace the status of an individual email sent to a single user. Example response { &quot;dispatch_id&quot;: Out-of-the-box generated Unique ID of the instance of this send &quot;status&quot;: Current status of the message &quot;metadata&quot;: Object containing additional information about the send instance } Transactional HTTP Event Postback All transactional emails are complemented with event status postbacks sent as an HTTP request back to your specified URL. This will allow you to evaluate the message status in real-time and take action to reach the user on another channel if the message goes undelivered, or fallback to an internal system if Braze is experiencing latency. In order to associate the incoming events to a particular instance of send, you can choose to either capture and store the Braze dispatch_id returned in the API response , or pass your own identifier to the external_send_id field. An example of a value you may choose to pass to that field may be an order ID, where after completing order 1234, an order confirmation message is triggered to the user through Braze, and external_send_id : 1234 is included in the request. All following event postbacks such as Sent and Delivered will include external_send_id : 1234 in the payload allowing you to confirm that user successfully received their order confirmation email. To get started using the Transactional HTTP Event Postback, navigate to Manage Settings &gt; Email Settings &gt; Transactional Webpush URL in your Braze dashboard and input your desired URL to receive postbacks. Postback body // Sent Event { &quot;dispatch_id&quot;: &quot;acf471119f7449d579e8089032003ded&quot;, &quot;status&quot;: &quot;sent&quot;, &quot;metadata&quot;: { &quot;received_at&quot;: &quot;2020-08-31T18:58:41.000+00:00&quot;, &quot;enqueued_at&quot;: &quot;2020-08-31T18:58:41.000+00:00&quot;, &quot;executed_at&quot;: &quot;2020-08-31T18:58:41.000+00:00&quot;, &quot;sent_at&quot;: &quot;2020-08-31T18:58:42.000+00:00&quot;, &quot;campaign_api_id&quot;: &quot;417220e4-5a2a-b634-7f7d-9ec891532368&quot;, &quot;external_send_id&quot; : &quot;34a2ceb3cf6184132f3d816e9984269a&quot; } } // Processed Event { &quot;dispatch_id&quot;: &quot;acf471119f7449d579e8089032003ded&quot;, &quot;status&quot;: &quot;processed&quot;, &quot;metadata&quot;: { &quot;processed_at&quot;: &quot;2020-08-31T18:58:42.000+00:00&quot;, &quot;campaign_api_id&quot;: &quot;417220e4-5a2a-b634-7f7d-9ec891532368&quot;, &quot;external_send_id&quot; : &quot;34a2ceb3cf6184132f3d816e9984269a&quot; } } // Aborted { &quot;dispatch_id&quot;: &quot;acf471119f7449d579e8089032003ded&quot;, &quot;status&quot;: &quot;aborted&quot;, &quot;metadata&quot;: { &quot;reason&quot;: &quot;User not emailable&quot;, &quot;aborted_at&quot;: &quot;2020-08-31T19:04:51.000+00:00&quot;, &quot;campaign_api_id&quot;: &quot;417220e4-5a2a-b634-7f7d-9ec891532368&quot;, &quot;external_send_id&quot; : &quot;34a2ceb3cf6184132f3d816e9984269a&quot; } } // Delivered Event { &quot;dispatch_id&quot;: &quot;acf471119f7449d579e8089032003ded&quot;, &quot;status&quot;: &quot;delivered&quot;, &quot;metadata&quot;: { &quot;delivered_at&quot;: &quot;2020-08-31T18:27:32.000+00:00&quot;, &quot;campaign_api_id&quot;: &quot;417220e4-5a2a-b634-7f7d-9ec891532368&quot;, &quot;external_send_id&quot; : &quot;34a2ceb3cf6184132f3d816e9984269a&quot; } } // Bounced Event { &quot;dispatch_id&quot;: &quot;acf471119f7449d579e8089032003ded&quot;, &quot;status&quot;: &quot;bounced&quot;, &quot;metadata&quot;: { &quot;bounced_at&quot;: &quot;2020-08-31T18:58:43.000+00:00&quot;, &quot;reason&quot;: &quot;550 5.1.1 The email account that you tried to reach does not exist&quot;, &quot;campaign_api_id&quot;: &quot;417220e4-5a2a-b634-7f7d-9ec891532368&quot;, &quot;external_send_id&quot; : &quot;34a2ceb3cf6184132f3d816e9984269a&quot; } } Message status Status Description sent Message successfully dispatched to Braze’s email sending partner processed Email sending partner has successfully received and prepared the message for sending to the user’s inbox provider aborted Braze was unable to successfully dispatch the message due to the user not having an emailable address, or Liquid abort logic was called in the message body. All aborted events include a reason field within the metadata object indicating why the message was aborted delivered Message was accepted by the user’s email inbox provider bounced Message was rejected by the user’s email inbox provider. All bounced events include a reason field within the metadata object reflecting the bounce error code provided by the inbox provider Example postback // Sent Event { &quot;dispatch_id&quot;: &quot;acf471119f7449d579e8089032003ded&quot;, &quot;status&quot;: &quot;sent&quot;, &quot;metadata&quot;: { &quot;received_at&quot;: &quot;2020-08-31T18:58:41.000+00:00&quot;, &quot;enqueued_at&quot;: &quot;2020-08-31T18:58:41.000+00:00&quot;, &quot;executed_at&quot;: &quot;2020-08-31T18:58:41.000+00:00&quot;, &quot;sent_at&quot;: &quot;2020-08-31T18:58:42.000+00:00&quot;, &quot;campaign_api_id&quot;: &quot;417220e4-5a2a-b634-7f7d-9ec891532368&quot;, &quot;external_send_id&quot; : &quot;34a2ceb3cf6184132f3d816e9984269a&quot; } } // Processed Event { &quot;dispatch_id&quot;: &quot;acf471119f7449d579e8089032003ded&quot;, &quot;status&quot;: &quot;processed&quot;, &quot;metadata&quot;: { &quot;processed_at&quot;: &quot;2020-08-31T18:58:42.000+00:00&quot;, &quot;campaign_api_id&quot;: &quot;417220e4-5a2a-b634-7f7d-9ec891532368&quot;, &quot;external_send_id&quot; : &quot;34a2ceb3cf6184132f3d816e9984269a&quot; } } // Aborted { &quot;dispatch_id&quot;: &quot;acf471119f7449d579e8089032003ded&quot;, &quot;status&quot;: &quot;aborted&quot;, &quot;metadata&quot;: { &quot;reason&quot;: &quot;User not emailable&quot;, &quot;aborted_at&quot;: &quot;2020-08-31T19:04:51.000+00:00&quot;, &quot;campaign_api_id&quot;: &quot;417220e4-5a2a-b634-7f7d-9ec891532368&quot;, &quot;external_send_id&quot; : &quot;34a2ceb3cf6184132f3d816e9984269a&quot; } } // Delivered Event { &quot;dispatch_id&quot;: &quot;acf471119f7449d579e8089032003ded&quot;, &quot;status&quot;: &quot;delivered&quot;, &quot;metadata&quot;: { &quot;delivered_at&quot;: &quot;2020-08-31T18:27:32.000+00:00&quot;, &quot;campaign_api_id&quot;: &quot;417220e4-5a2a-b634-7f7d-9ec891532368&quot;, &quot;external_send_id&quot; : &quot;34a2ceb3cf6184132f3d816e9984269a&quot; } } // Bounced Event { &quot;dispatch_id&quot;: &quot;acf471119f7449d579e8089032003ded&quot;, &quot;status&quot;: &quot;bounced&quot;, &quot;metadata&quot;: { &quot;bounced_at&quot;: &quot;2020-08-31T18:58:43.000+00:00&quot;, &quot;reason&quot;: &quot;550 5.1.1 The email account that you tried to reach does not exist&quot;, &quot;campaign_api_id&quot;: &quot;417220e4-5a2a-b634-7f7d-9ec891532368&quot;, &quot;external_send_id&quot; : &quot;34a2ceb3cf6184132f3d816e9984269a&quot; } } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.MessagingSendMessages.html#transactional_v1_campaigns_yourcampaignidhere_send_post/2","title":"BrazeEx.Api.MessagingSendMessages.transactional_v1_campaigns_yourcampaignidhere_send_post/2","type":"function"},{"doc":"API calls for all endpoints tagged SCIM .","ref":"BrazeEx.Api.SCIM.html","title":"BrazeEx.Api.SCIM","type":"module"},{"doc":"Search Existing Dashboard User by Email This endpoint allows you to look up an existing dashboard user account by specifying their email in the filter query parameter. Note that when the query parameter is URL encoded it will read like this: /scim/v2/Users?filter=userName eq &quot;user@test.com&quot; For information on how to obtain a SCIM token, visit  Automated user provisioning . Rate limit This endpoint has a rate limit of 5000 requests per day, per company. This rate limit is shared with the  /scim/v2/Users/  PUT, GET, DELETE, and POST endpoints as documented in  API rate limits . Response Content-Type: application/json X-Request-Origin: YOUR-REQUEST-ORIGIN-HERE Authorization: Bearer YOUR-SCIM-TOKEN-HERE { &quot;schemas&quot;: [&quot;urn:ietf:params:scim:api:messages:2.0:ListResponse&quot;], &quot;totalResults&quot;: 1, &quot;Resources&quot;: [ { &quot;userName&quot;: &quot;user@test.com&quot;, &quot;id&quot;: &quot;dfa245b7-24195aec-887bb3ad-602b3340&quot;, &quot;name&quot;: { &quot;givenName&quot;: &quot;Test&quot;, &quot;familyName&quot;: &quot;User&quot; }, &quot;department&quot;: &quot;finance&quot;, &quot;lastSignInAt&quot;: &quot;Thursday, January 1, 1970 12:00:00 AM&quot;, &quot;permissions&quot;: { &quot;companyPermissions&quot;: [&quot;manage_company_settings&quot;], &quot;appGroup&quot;: [ { &quot;appGroupId&quot;: &quot;241adcd25789fabcded&quot;, &quot;appGroupName&quot;: &quot;Test App Group&quot;, &quot;appGroupPermissions&quot;: [&quot;basic_access&quot;,&quot;send_campaigns_canvases&quot;], &quot;team&quot;: [ { &quot;teamId&quot;: &quot;241adcd25789fabcded&quot;, &quot;teamName&quot;: &quot;Test Team&quot;, &quot;teamPermissions&quot;: [&quot;admin&quot;] } ] } ] } } ] } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :x_request_origin (String.t): :authorization (String.t): :filter (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.SCIM.html#scim_v2_users_get/2","title":"BrazeEx.Api.SCIM.scim_v2_users_get/2","type":"function"},{"doc":"Create New Dashboard User Account This endpoint allows you to create a new dashboard user account by specifying email, given and family names, permissions (for setting permissions at the company, app group, and team level). For information on how to obtain a SCIM token, visit Automated user provisioning . Rate limit This endpoint has a rate limit of 5000 requests per day, per company. This rate limit is shared with the /scim/v2/Users/ PUT, GET, and DELETE endpoints as documented in API rate limits . Request parameters Parameter Required Data type Description schemas Required Array of strings Expected SCIM 2.0 schema name for user object. userName Required String The user’s email address. name Required JSON object This object contains the user's given name and family name. department Required String Valid department string from the department string documentation . permissions Required JSON object Permissions object as described in the permissions object documentation . Response { &quot;schemas&quot;: [&quot;urn:ietf:params:scim:schemas:core:2.0:User&quot;], &quot;id&quot;: &quot;dfa245b7-24195aec-887bb3ad-602b3340&quot;, &quot;userName&quot;: &quot;user@test.com&quot;, &quot;name&quot;: { &quot;givenName&quot;: &quot;Test&quot;, &quot;familyName&quot;: &quot;User&quot; }, &quot;department&quot;: &quot;finance&quot;, &quot;lastSignInAt&quot;: &quot;Thursday, January 1, 1970 12:00:00 AM&quot;, &quot;permissions&quot;: { &quot;companyPermissions&quot;: [&quot;manage_company_settings&quot;], &quot;appGroup&quot;: [ { &quot;appGroupId&quot;: &quot;241adcd25789fabcded&quot;, &quot;appGroupName&quot;: &quot;Test App Group&quot;, &quot;appGroupPermissions&quot;: [&quot;basic_access&quot;,&quot;send_campaigns_canvases&quot;], &quot;team&quot;: [ { &quot;teamId&quot;: &quot;2519dafcdba238ae7&quot;, &quot;teamName&quot;: &quot;Test Team&quot;, &quot;teamPermissions&quot;: [&quot;basic_access&quot;,&quot;export_user_data&quot;] } ] } ] } } Error states If a user with this email address already exists in Braze, the endpoint will respond with: HTTP/1.1 409 Conflict Date: Tue, 10 Sep 2019 02:22:30 GMT Content-Type: text/json;charset=UTF-8 { &quot;schemas&quot;: [&quot;urn:ietf:params:scim:api:messages:2.0:Error&quot;], &quot;detail&quot;: &quot;User already exists in the database.&quot;, &quot;status&quot;: 409 } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :x_request_origin (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.SCIM.html#scim_v2_users_post/2","title":"BrazeEx.Api.SCIM.scim_v2_users_post/2","type":"function"},{"doc":"Remove Dashboard User Account This endpoint allows you to permanently delete an existing dashboard user by specifying the resource id returned by the SCIM POST method. This is similar to deleting a user in the Manage Users section of the Braze dashboard. For information on how to obtain a SCIM token, visit Automated user provisioning . Rate limit This endpoint has a rate limit of 5000 requests per day, per company. This rate limit is shared with the /scim/v2/Users/ PUT, GET, and POST endpoints as documented in API rate limits . Request parameters Parameter Required Data type Description id Required String The user’s resource ID. This parameter is returned by the POST /scim/v2/Users/ or GET /scim/v2/Users?filter=userName eq &quot;[user@test.com](mailto:user@test.com)&quot; methods. Response HTTP/1.1 204 Not Found Content-Type: text/html; charset=UTF-8 Error states If a developer with this ID doesn’t exist in Braze, the endpoint will respond with: HTTP/1.1 404 Not Found Content-Type: text/html; charset=UTF-8 { &quot;schemas&quot;: [&quot;urn:ietf:params:scim:api:messages:2.0:Error&quot;], &quot;detail&quot;: &quot;User not found&quot;, &quot;status&quot;: 404 } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :x_request_origin (String.t): :authorization (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.SCIM.html#scim_v2_users_youridhere_delete/2","title":"BrazeEx.Api.SCIM.scim_v2_users_youridhere_delete/2","type":"function"},{"doc":"Look Up an Existing Dashboard User Account This endpoint allows you to look up an existing dashboard user account by specifying the resource id returned by the SCIM POST method. For information on how to obtain a SCIM token, visit Automated user provisioning . Rate limit This endpoint has a rate limit of 5000 requests per day, per company. This rate limit is shared with the /scim/v2/Users/ PUT, GET, DELETE, and POST endpoints as documented in API rate limits . Request parameters Parameter Required Data type Description id Required String The user’s resource ID. This parameter is returned by the POST /scim/v2/Users/ or GET /scim/v2/Users?filter=userName eq &quot;user@test.com&quot; methods. Response { &quot;schemas&quot;: [&quot;urn:ietf:params:scim:schemas:core:2.0:User&quot;], &quot;id&quot;: &quot;dfa245b7-24195aec-887bb3ad-602b3340&quot;, &quot;userName&quot;: &quot;user@test.com&quot;, &quot;name&quot;: { &quot;givenName&quot;: &quot;Test&quot;, &quot;familyName&quot;: &quot;User&quot; }, &quot;department&quot;: &quot;finance&quot;, &quot;lastSignInAt&quot;: &quot;Thursday, January 1, 1970 12:00:00 AM&quot;, &quot;permissions&quot;: { &quot;companyPermissions&quot;: [&quot;manage_company_settings&quot;], &quot;appGroup&quot;: [ { &quot;appGroupId&quot;: &quot;241adcd25789fabcded&quot;, &quot;appGroupName&quot;: &quot;Test App Group&quot;, &quot;appGroupPermissions&quot;: [&quot;basic_access&quot;,&quot;send_campaigns_canvases&quot;], &quot;team&quot;: [ { &quot;teamId&quot;: &quot;241adcd25789fabcded&quot;, &quot;teamName&quot;: &quot;Test Team&quot;, &quot;teamPermissions&quot;: [&quot;admin&quot;] } ] } ] } } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :x_request_origin (String.t): :authorization (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.SCIM.html#scim_v2_users_youridhere_get/2","title":"BrazeEx.Api.SCIM.scim_v2_users_youridhere_get/2","type":"function"},{"doc":"Update Dashboard User Account This endpoint allows you to update an existing dashboard user account by specifying the resource id returned by the SCIM POST method. It allows you to update of given and family names, permissions (for setting permissions at the company, app group, and team level) and department. For information on how to obtain a SCIM token, visit Automated user provisioning . For security reasons, userName (email address) cannot be updated through this endpoint. If you would like to change the userName (email address) for a user, contact Support . Rate limit This endpoint has a rate limit of 5000 requests per day, per company. This rate limit is shared with the /scim/v2/Users/ GET, DELETE, and POST endpoints as documented in API rate limits . Request parameters Parameter Required Data type Description id Required String The user’s resource ID. This parameter is returned by the POST /scim/v2/Users/ or GET /scim/v2/Users?filter=userName eq &quot;user@test.com&quot; methods. schemas Required Array of strings Expected SCIM 2.0 schema name for user object. name Required JSON object This object contains the user's given name and family name. department Required String Valid department string from the department string documentation . permissions Required JSON object Permissions object as described in the permissions object documentation . Response { &quot;schemas&quot;: [&quot;urn:ietf:params:scim:schemas:core:2.0:User&quot;], &quot;id&quot;: &quot;dfa245b7-24195aec-887bb3ad-602b3340&quot;, &quot;userName&quot;: &quot;user@test.com&quot;, &quot;name&quot;: { &quot;givenName&quot;: &quot;Test&quot;, &quot;familyName&quot;: &quot;User&quot; }, &quot;department&quot;: &quot;finance&quot;, &quot;lastSignInAt&quot;: &quot;Thursday, January 1, 1970 12:00:00 AM&quot;, &quot;permissions&quot;: { &quot;companyPermissions&quot;: [&quot;manage_company_settings&quot;], &quot;appGroup&quot;: [ { &quot;appGroupId&quot;: &quot;241adcd25789fabcded&quot;, &quot;appGroupName&quot;: &quot;Test App Group&quot;, &quot;appGroupPermissions&quot;: [&quot;basic_access&quot;,&quot;send_campaigns_canvases&quot;], &quot;team&quot;: [ { &quot;teamId&quot;: &quot;2519dafcdba238ae7&quot;, &quot;teamName&quot;: &quot;Test Team&quot;, &quot;teamPermissions&quot;: [&quot;admin&quot;] } ] } ] } } Error states If a user with this ID doesn’t exist in Braze, the endpoint will respond with: HTTP/1.1 404 Not Found Content-Type: text/html; charset=UTF-8 { &quot;schemas&quot;: [&quot;urn:ietf:params:scim:api:messages:2.0:Error&quot;], &quot;detail&quot;: &quot;User not found&quot;, &quot;status&quot;: 404 } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :x_request_origin (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.SCIM.html#scim_v2_users_youridhere_put/2","title":"BrazeEx.Api.SCIM.scim_v2_users_youridhere_put/2","type":"function"},{"doc":"API calls for all endpoints tagged SMS .","ref":"BrazeEx.Api.SMS.html","title":"BrazeEx.Api.SMS","type":"module"},{"doc":"Query Invalid Phone Numbers Use this endpoint to pull a list of phone numbers that have been deemed “invalid” within a certain time frame. If you provide a start_date , an end_date , and phone_numbers , we prioritize the given phone numbers and disregard the date range. If your date range has more than the limit number of invalid phone numbers, you will need to make multiple API calls with increasing the offset each time until a call returns either fewer than limit or zero results. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Entries are listed in descending order. Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;sms&quot;: [ { &quot;phone&quot;: &quot;12345678900&quot;, &quot;invalid_detected_at&quot;: &quot;2016-08-25 15:24:32 +0000&quot; }, { &quot;phone&quot;: &quot;12345678901&quot;, &quot;invalid_detected_at&quot;: &quot;2016-08-24 17:41:58 +0000&quot; }, { &quot;phone&quot;: &quot;12345678902&quot;, &quot;invalid_detected_at&quot;: &quot;2016-08-24 12:01:13 +0000&quot; } ], &quot;message&quot;: &quot;success&quot; } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :start_date (String.t): (Optional*) String in YYYY-MM-DD format Start date of the range to retrieve invalid phone numbers, must be earlier than end_date . This is treated as midnight in UTC time by the API. :end_date (String.t): (Optional*) String in YYYY-MM-DD format End date of the range to retrieve invalid phone numbers. This is treated as midnight in UTC time by the API. :limit (integer()): (Optional) Integer Optional field to limit the number of results returned. Defaults to 100, maximum is 500. :offset (integer()): (Optional) Integer Optional beginning point in the list to retrieve from. :phone_numbers (integer()): (Optional*) Array of Strings in e.164 format If provided, we will return the phone number if it has been found to be invalid. Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.SMS.html#sms_invalid_phone_numbers_get/2","title":"BrazeEx.Api.SMS.sms_invalid_phone_numbers_get/2","type":"function"},{"doc":"Remove Invalid Phone Numbers Use this endpoint to remove “invalid” phone numbers from Braze’s invalid list. This can be used to re-validate phone numbers after they have been marked as invalid. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Request parameters Parameter Required Data Type Description phone_number Required Array of strings in e.164 format An array of up to 50 phone numbers to modify. Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :content_type (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.SMS.html#sms_invalid_phone_numbers_remove_post/2","title":"BrazeEx.Api.SMS.sms_invalid_phone_numbers_remove_post/2","type":"function"},{"doc":"API calls for all endpoints tagged SubscriptionGroupsSMS .","ref":"BrazeEx.Api.SubscriptionGroupsSMS.html","title":"BrazeEx.Api.SubscriptionGroupsSMS","type":"module"},{"doc":"List User's Subscription Group Status - SMS Use this endpoint to get the subscription state of a user in a subscription group. These groups will be available on the  Subscription Group  page. The response from this endpoint will include the external ID and either subscribed, unsubscribed, or unknown for the specific subscription group requested in the API call. This can be used to update the subscription group state in subsequent API calls or to be displayed on a hosted web page. *Either external_id or email are required. When both are submitted, only the external_id is used for querying and the phone number is applied to that user. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response All successful responses will return subscribed , unsubscribed , or unknown depending on status and user history with the subscription group. Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;status&quot;: { &quot;1&quot;: &quot;Unsubscribed&quot;, &quot;2&quot;: &quot;Subscribed&quot; }, &quot;message&quot;: &quot;success&quot; } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :subscription_group_id (String.t): (Required) String The id of your subscription group. :external_id (String.t): (Required*) String The external_id of the user (must include at least one and at most 50 external_ids ). When both an external_id and phone are submitted, only the external_id(s) provided will be applied to the result query. :phone (float()): (Required*) String in E.164 format The phone number of the user (must include at least one phone number and at most 50 phone numbers). Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.SubscriptionGroupsSMS.html#subscription_status_get_get/2","title":"BrazeEx.Api.SubscriptionGroupsSMS.subscription_status_get_get/2","type":"function"},{"doc":"Update User's Subscription Group Status - SMS Use this endpoint to batch update the subscription state of up to 50 users on the Braze dashboard. You can access a subscription group’s subscription_group_id by navigating to the Subscription Group page. *Only external_id or phone is accepted for SMS subscription groups. This property should not be used for updating a user’s profile information. Use the /users/track property instead. When creating new users via the /users/track endpoint, you should leave a delay of around 2 minutes before adding users to the relevant Subscription Group to allow Braze time to fully create the user profile. Rate limit For customers who onboarded with Braze on or after January 6, 2022, we apply a rate limit of 5,000 requests per minute shared across the  /subscription/status/set  and  /v2/subscription/status/set  endpoint as documented in  API rate limits . Request parameters Parameter Required Data Type Description subscription_group_id Required String The id of your subscription group. subscription_state Required String Available values are unsubscribed (not in subscription group) or subscribed (in subscription group). external_id Required* Array of strings The external_id of the user or users, may include up to 50 id s. phone Required* String in E.164 format The phone number of the user, can be passed as an array of strings. Must include at least one phone number (with a max of 50). Example successful response Response: (status 201) { &quot;message&quot;: &quot;success&quot; } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.SubscriptionGroupsSMS.html#subscription_status_set_post/2","title":"BrazeEx.Api.SubscriptionGroupsSMS.subscription_status_set_post/2","type":"function"},{"doc":"List User's Subscription Group - SMS Use this endpoint to list and get the subscription groups of a certain user. If there are multiple users (multiple external ids) who share the same email address, all users will be returned as a separate user (even if they have the same email address or subscription group). Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :external_id (String.t): (Required*) String The external_id of the user (must include at least one and at most 50 external_ids ). :limit (integer()): (Optional) Integer The limit on the maximum number of results returned. Default (and max) limit is 100. :offset (integer()): (Optional) Integer Number of templates to skip before returning the rest of the templates that fit the search criteria. :phone (float()): (Required*) String in E.164 format The phone number of the user. Must include at least one phone number (with a max of 50). Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.SubscriptionGroupsSMS.html#subscription_user_status_get/2","title":"BrazeEx.Api.SubscriptionGroupsSMS.subscription_user_status_get/2","type":"function"},{"doc":"Update User's Subscription Group Status V2 Use this endpoint to batch update the subscription state of up to 50 users on the Braze dashboard. You can access a subscription group’s subscription_group_id by navigating to the Subscriptions Group page. Rate limit For customers who onboarded with Braze on or after January 6, 2022, we apply a rate limit of 5,000 requests per minute shared across the  /subscription/status/set  and  /v2/subscription/status/set  endpoint as documented in  API rate limits . Request parameters Parameter Required Data Type Description subscription_group_id Required String The id of your subscription group. subscription_state Required String Available values are unsubscribed (not in subscription group) or subscribed (in subscription group). external_ids Required* Array of strings The external_id of the user or users, may include up to 50 id s. phones Required* String in E.164 format The phone numbers of the user, can be passed as an array of strings. Must include at least one phone number (with a max of 50). Example successful response Response: (status 201) { &quot;message&quot;: &quot;success&quot; } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.SubscriptionGroupsSMS.html#v2_subscription_status_set_post/2","title":"BrazeEx.Api.SubscriptionGroupsSMS.v2_subscription_status_set_post/2","type":"function"},{"doc":"API calls for all endpoints tagged TemplatesContentBlocks .","ref":"BrazeEx.Api.TemplatesContentBlocks.html","title":"BrazeEx.Api.TemplatesContentBlocks","type":"module"},{"doc":"Create Content Block Use this endpoint to create a  Content Block . Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Request parameters Parameter Required Data Type Description name Required String Name of the content block. Must be less than 100 characters. description Optional String Description of the content block. Must be less than 250 characters. content Required String HTML or text content within the Content Block. state Optional String Choose active or draft . Defaults to active if not specified. tags Optional Array of strings Tags must already exist. Response { &quot;content_block_id&quot;: &quot;newly-generated-block-id&quot;, &quot;liquid_tag&quot;: &quot;generated-block-tag-from-name&quot;, &quot;created_at&quot;: &quot;time-created-in-iso&quot;, &quot;message&quot;: success } Possible errors The following table lists possible returned errors and their associated troubleshooting steps, if applicable. Error Troubleshooting Content cannot be blank Content must be a string Make sure your content is encapsulated in quotes ( &quot;&quot; ). Content must be smaller than 50kb The content in your Content Block must be less than 50kb total. Content contains malformed liquid The Liquid provided is not valid or parsable. Try again with valid Liquid or reach out to support. Content Block cannot be referenced within itself Content Block description cannot be blank Content Block description must be a string Make sure your Content Block description is encapsulated in quotes ( &quot;&quot; ). Content Block description must be shorter than 250 characters Content Block name cannot be blank Content Block name must be shorter than 100 characters Content Block name can only contain alphanumeric characters Content Block names can include any of the following characters: the letters (capitalized or lowercase) A through Z , the numbers 0 through 9 , dashes - , and underscores _ . It cannot contain non-alphanumeric characters like emojis, ! , @ , ~ , &amp; , and other &quot;special&quot; characters. Content Block with this name already exists Try a different name. Content Block state must be either active or draft Tags must be an array Tags must be formatted as an array of strings, for example [&quot;marketing&quot;, &quot;promotional&quot;, &quot;transactional&quot;] . All tags must be strings Make sure your tags are encapsulated in quotes ( &quot;&quot; ). Some tags could not be found To add a tag when creating a Content Block, the tag must already exist in Braze. Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.TemplatesContentBlocks.html#content_blocks_create_post/2","title":"BrazeEx.Api.TemplatesContentBlocks.content_blocks_create_post/2","type":"function"},{"doc":"See Content Block Information Use this endpoint to call information for your existing  Content Blocks . Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Content-Type: application/json Authorization: Bearer YOUR_REST_API_KEY { &quot;content_block_id&quot;: &quot;string&quot;, &quot;name&quot;: &quot;string&quot;, &quot;content&quot;: &quot;string&quot;, &quot;description&quot;: &quot;string&quot;, &quot;content_type&quot;: &quot;html or text&quot;, &quot;tags&quot;: &quot;array of strings&quot;, &quot;created_at&quot;: &quot;time-in-iso&quot;, &quot;last_edited&quot;: &quot;time-in-iso&quot;, &quot;inclusion_count&quot; : &quot;integer&quot;, &quot;message&quot;: &quot;success&quot; } Possible errors The following table lists possible returned errors and their associated troubleshooting steps. Error Troubleshooting Content Block ID cannot be blank Make sure that a Content Block is listed in your request and is encapsulated in quotes ( &quot;&quot; ). Content Block ID is invalid for this App Group This Content Block doesn't exist or is in a different company account or app group. Content Block has been deleted—content not available This Content Block, though it may have existed earlier, has been deleted. Include Inclusion Data—error This parameter only accepts boolean values (true or false). Make sure the value for include_inclusion_data is not encapsulated in quotes ( &quot;&quot; ), which causes the value to be sent as a string instead. See request parameters for details. Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :content_block_id (String.t): (Required) String The content block identifier. You can find this by either listing content block information through an API call or going to Developer Console &gt; API Settings , then scrolling to the bottom and searching for your content block API identifier. :include_inclusion_data (boolean()): (Optional) Boolean When set to true , the API returns back the Message Variation API identifier of campaigns and Canvases where this content block is included, to be used in subsequent calls. The results exclude archived or deleted Campaigns or Canvases. Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.TemplatesContentBlocks.html#content_blocks_info_get/2","title":"BrazeEx.Api.TemplatesContentBlocks.content_blocks_info_get/2","type":"function"},{"doc":"List Available Content Blocks Use this endpoint to list your existing  Content Blocks  information. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Content-Type: application/json Authorization: Bearer YOUR_REST_API_KEY { &quot;count&quot;: &quot;integer&quot;, &quot;content_blocks&quot;: [ { &quot;content_block_id&quot;: &quot;string&quot;, &quot;name&quot;: &quot;string&quot;, &quot;content_type&quot;: &quot;html or text&quot;, &quot;liquid_tag&quot;: &quot;string&quot;, &quot;inclusion_count&quot; : &quot;integer&quot;, &quot;created_at&quot;: &quot;time-in-iso&quot;, &quot;last_edited&quot;: &quot;time-in-iso&quot;, &quot;tags&quot; : &quot;array of strings&quot; } ] } Possible errors The following table lists possible returned errors and their associated troubleshooting steps. Error Troubleshooting Modified after time is invalid The provided date is not a valid or parsable date. Reformat this value as a string in ISO 8601 format ( yyyy-mm-ddThh:mm:ss.ffffff ). Modified before time is invalid The provided date is not a valid or parsable date. Reformat this value as a string in ISO 8601 format ( yyyy-mm-ddThh:mm:ss.ffffff ). Modified after time must be earlier than or the same as modified before time. Change the modified_after value to a time that is earlier than the modified_before time. Content Block number limit is invalid The limit parameter must be an integer (positive number) greater than 0. Content Block number limit must be greater than 0 Change the limit parameter to an integer greater than 0. Content Block number limit exceeds maximum of 1000 Change the limit parameter to an integer less than 1000. Offset is invalid The offset parameter must be an integer greater than 0. Offset must be greater than 0 Change the offset parameter to an integer greater than 0. Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :modified_after (String.t): (Optional) String in ISO 8601 Retrieve only content blocks updated at or after the given time. :modified_before (String.t): (Optional) String in ISO 8601 Retrieve only content blocks updated at or before the given time. :limit (integer()): (Optional) Positive Number Maximum number of content blocks to retrieve. Default to 100 if not provided, with a maximum acceptable value of 1000. :offset (integer()): (Optional) Positive Number Number of content blocks to skip before returning rest of the templates that fit the search criteria. Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.TemplatesContentBlocks.html#content_blocks_list_get/2","title":"BrazeEx.Api.TemplatesContentBlocks.content_blocks_list_get/2","type":"function"},{"doc":"Update Content Block Use this endpoint to update a  Content Block . Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits Request parameters Parameter Required Data Type Description content_block_id Required String Your content block's API identifier. name Required String Name of the content block. Must be less than 100 characters. description Optional String Description of the content block. Must be less than 250 characters. content Required String HTML or text content within content blocks. state Optional String Choose active or draft . Defaults to active if not specified. tags Optional Array of strings Tags must already exist. Response { &quot;content_block_id&quot;: &quot;newly-generated-block-id&quot;, &quot;liquid_tag&quot;: &quot;generated-block-tag-from-content_block_name&quot;, &quot;created_at&quot;: &quot;time-created-in-iso&quot;, &quot;message&quot;: &quot;success&quot; } Possible errors The following table lists possible returned errors and their associated troubleshooting steps, if applicable. Error Troubleshooting Content cannot be blank Content must be a string Make sure your content is encapsulated in quotes ( &quot;&quot; ). Content must be smaller than 50kb The content in your Content Block must be less than 50kb total. Content contains malformed liquid The Liquid provided is not valid or parsable. Try again with valid Liquid or reach out to support. Content Block cannot be referenced within itself Content Block description cannot be blank Content Block description must be a string Make sure your Content Block description is encapsulated in quotes ( &quot;&quot; ). Content Block description must be shorter than 250 characters Content Block name cannot be blank Content Block name must be shorter than 100 characters Content Block name can only contain alphanumeric characters Content Block names can include any of the following characters: the letters (capitalized or lowercase) A through Z , the numbers 0 through 9 , dashes - , and underscores _ . It cannot contain non-alphanumeric characters like emojis, ! , @ , ~ , &amp; , and other &quot;special&quot; characters. Content Block with this name already exists Try a different name. Content Block name cannot be updated for active Content Blocks Content Block state must be either active or draft Active Content Block can not be updated to Draft. Create a new Content Block Tags must be an array Tags must be formatted as an array of strings, for example [&quot;marketing&quot;, &quot;promotional&quot;, &quot;transactional&quot;] . All tags must be strings Make sure your tags are encapsulated in quotes ( &quot;&quot; ). Some tags could not be found To add a tag when creating a Content Block, the tag must already exist in Braze. Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.TemplatesContentBlocks.html#content_blocks_update_post/2","title":"BrazeEx.Api.TemplatesContentBlocks.content_blocks_update_post/2","type":"function"},{"doc":"API calls for all endpoints tagged TemplatesEmailTemplates .","ref":"BrazeEx.Api.TemplatesEmailTemplates.html","title":"BrazeEx.Api.TemplatesEmailTemplates","type":"module"},{"doc":"Create Email Template Use this endpoint to create email templates on the Braze dashboard. These templates will be available on the Templates &amp; Media page. The response from this endpoint will include a field for email_template_id , which can be used to update the template in subsequent API calls. Users’ email subscription status can be updated and retrieved via Braze using a RESTful API. You can use the API to set up bi-directional sync between Braze and other email systems or your own database. All API requests are made over HTTPS. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Request parameters Parameter Required Data Type Description template_name Required String Name of your email template. subject Required String Email template subject line. body Required String Email template body that may include HTML. plaintext_body Optional String A plaintext version of the email template body. preheader Optional String Email preheader used to generate previews in some clients. tags Optional String Tags must already exist. should_inline_css Optional Boolean Enables or disables the inline_css feature per template. If not provided, Braze will use the default setting for the app group. One of true or false is expected. Possible errors The following table lists possible returned errors and their associated troubleshooting steps, if applicable. Error Troubleshooting Template name is required Enter a template name. Tags must be an array Tags must be formatted as an array of strings, for example [&quot;marketing&quot;, &quot;promotional&quot;, &quot;transactional&quot;] . All tags must be strings Make sure your tags are encapsulated in quotes ( &quot;&quot; ). Some tags could not be found To add a tag when creating an email template, the tag must already exist in Braze. Email must have valid Content Block names The email contains Content Blocks that don't exist in this environment. Invalid value for should_inline_css . One of true or false was expected This parameter only accepts boolean values (true or false). Make sure the value for should_inline_css is not encapsulated in quotes ( &quot;&quot; ), which causes the value to be sent as a string instead. Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.TemplatesEmailTemplates.html#templates_email_create_post/2","title":"BrazeEx.Api.TemplatesEmailTemplates.templates_email_create_post/2","type":"function"},{"doc":"See Email Template Information Use this endpoint to get information on your email templates. Important: Templates built using the Drag &amp; Drop Editor are not accepted. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Content-Type: application/json Authorization: Bearer YOUR-REST-API-KEY { &quot;email_template_id&quot;: (string) your email template's API Identifier, &quot;template_name&quot;: (string) the name of your email template, &quot;description&quot;: (string) email template description, &quot;subject&quot;: (string) the email template subject line, &quot;preheader&quot;: (optional, string) the email preheader used to generate previews in some clients), &quot;body&quot;: (optional, string) the email template body that may include HTML, &quot;plaintext_body&quot;: (optional, string) a plaintext version of the email template body, &quot;should_inline_css&quot;: (optional, boolean) whether there is inline CSS in the body of the template - defaults to the css inlining value for the App Group, &quot;tags&quot;: (string) tag names, &quot;created_at&quot;: (string, in ISO 8601), &quot;updated_at&quot;: (string, in ISO 8601) } Images in this response will show in the body variable as HTML. Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :email_template_id (String.t): (Required) String See email template's API identifier . Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.TemplatesEmailTemplates.html#templates_email_info_get/2","title":"BrazeEx.Api.TemplatesEmailTemplates.templates_email_info_get/2","type":"function"},{"doc":"List Available Email Templates Use this endpoint to get a list of available templates in your Braze account. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Response Important: Templates built using the Drag &amp; Drop Editor are not provided in this response. { &quot;count&quot;: number of templates returned &quot;templates&quot;: [template with the following properties]: &quot;email_template_id&quot;: (string) your email template's API Identifier, &quot;template_name&quot;: (string) the name of your email template, &quot;created_at&quot;: (string, in ISO 8601), &quot;updated_at&quot;: (string, in ISO 8601), &quot;tags&quot;: (array of strings) tags appended to the template } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :authorization (String.t): :modified_after (String.t): (Optional) String in ISO 8601 Retrieve only templates updated at or after the given time. :modified_before (String.t): (Optional) String in ISO 8601 Retrieve only templates updated at or before the given time. :limit (integer()): (Optional) Positive Number Maximum number of templates to retrieve. Default to 100 if not provided, with a maximum acceptable value of 1000. :offset (integer()): (Optional) Positive Number Number of templates to skip before returning rest of the templates that fit the search criteria. Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.TemplatesEmailTemplates.html#templates_email_list_get/2","title":"BrazeEx.Api.TemplatesEmailTemplates.templates_email_list_get/2","type":"function"},{"doc":"Update Email Template Use this endpoint to update email templates on the Braze dashboard. You can access an email template’s email_template_id by navigating to it on the Templates &amp; Media page. The Create email template endpoint will also return an email_template_id reference. Use the endpoints below to update email templates on the Braze dashboard. You can access an email template's email_template_id by navigating to it on the Templates and Media page. The email template creation API endpoint will also return an email_template_id reference. All fields other than the email_template_id are optional, but you must specify at least one field to update. Rate limit We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in API rate limits . Request parameters Parameter Required Data Type Description email_template_id Required String Your email template's API identifier . template_name Optional String Name of your email template. subject Optional String Email template subject line. body Optional String Email template body that may include HTML. plaintext_body Optional String A plaintext version of the email template body. preheader Optional String Email preheader used to generate previews in some clients. tags Optional String Tags must already exist. should_inline_css Optional Boolean Enables or disables the inline_css feature per template. If not provided, Braze will use the default setting for the AppGroup. One of true or false is expected. Possible errors The following table lists possible returned errors and their associated troubleshooting steps, if applicable. Error Troubleshooting Template name is required Tags must be an array Tags must be formatted as an array of strings, for example [&quot;marketing&quot;, &quot;promotional&quot;, &quot;transactional&quot;] . All tags must be strings Make sure your tags are encapsulated in quotes ( &quot;&quot; ). Some tags could not be found To add a tag when creating an email template, the tag must already exist in Braze. Invalid value for should_inline_css . One of true or false was expected This parameter only accepts boolean values (true or false). Make sure the value for should_inline_css is not encapsulated in quotes ( &quot;&quot; ), which causes the value to be sent as a string instead. Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.TemplatesEmailTemplates.html#templates_email_update_post/2","title":"BrazeEx.Api.TemplatesEmailTemplates.templates_email_update_post/2","type":"function"},{"doc":"API calls for all endpoints tagged UserData .","ref":"BrazeEx.Api.UserData.html","title":"BrazeEx.Api.UserData","type":"module"},{"doc":"Create New User Aliases Use this endpoint to add new user aliases for existing identified users, or to create new unidentified users. Note: You can add up to 50 user aliases per request. Adding a user alias for an existing user requires an external_id to be included in the new user alias object. If the external_id is present in the object but there is no user with that external_id , the alias will not be added to any users. If an external_id is not present, a user will still be created, but will need to be identified later. You can do this using the &quot;Identifying Users&quot; and the users/identify endpoint&lt;br&gt;&lt;br&gt; Creating a new alias-only user requires the external_id to be omitted from the new user alias object. Once the user is created, use the /users/track endpoint to associate the alias-only user with attributes, events and purchases, and the /users/identify endpoint to identify the user with an external_id . Rate limit For customers who onboarded with Braze on or after September 16, 2021, we apply a shared rate limit of 20,000 requests per minute to this endpoint. This rate limit is shared with the /users/delete and /users/identify endpoints, as documented in API rate limits . Request parameters Parameter Required Data Type Description user_aliases Required Array of new user alias objects See user alias object .&lt;br&gt;&lt;br&gt; For more information on alias_name and alias_label , check out our User Aliases documentation. Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.UserData.html#users_alias_new_post/2","title":"BrazeEx.Api.UserData.users_alias_new_post/2","type":"function"},{"doc":"User Delete Use this endpoint to delete any user profile by specifying a known user identifier. Up to 50  external_ids ,  user_aliases , or  braze_ids  can be included in a single request. Only one of  external_ids ,  user_aliases , or  braze_ids  can be included in a single request. Important: Deleting user profiles cannot be undone. It will permanently remove users which may cause discrepancies in your data. Learn more about what happens when you delete a user profile via API in our Help documentation. Rate limit For customers who onboarded with Braze on or after September 16, 2021, we apply a shared rate limit of 20,000 requests per minute to this endpoint. This rate limit is shared with the /users/alias/new and /users/identify endpoints, as documented in API rate limits . Request parameter Parameter Required Data Type Description external_ids Optional Array of strings External identifiers for the users to delete. user_aliases Optional Array of user alias object User aliases for the users to delete. braze_ids Optional Array of strings Braze user identifiers for the users to delete. Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.UserData.html#users_delete_post/2","title":"BrazeEx.Api.UserData.users_delete_post/2","type":"function"},{"doc":"Identify Users Use this endpoint to identify an unidentified (alias-only) user. Calling  /users/identify  combines the alias-only profile with the identified profile and removes the alias-only profile. To prevent unexpected loss of data when identifying users, we highly recommend that you first refer to  data collection best practices  to learn about capturing user data when alias-only user info is already present. Note: You can add up to 50 user aliases per request. Identifying a user requires an external_id to be included in the aliases_to_identify object. If there is no user with that external_id , the external_id will simply be added to the aliased user’s record, and the user will be considered identified. You can associate multiple additional user aliases with a single external_id . When any of such associations are made, only the push tokens and message history associated with the user alias are retained; any attributes, events, or purchases will be “orphaned” and not available on the identified user. One workaround is to export the aliased user’s data before identification using the /users/export/ids endpoint , then re-associate the attributes, events, and purchases with the identified user. Important: Request fields and their values are case sensitive. Using different cases to reference an external_id will result in duplicate profiles. For example, “abc123” and “ABC123” are two different external_ids . Rate limit For customers who onboarded with Braze on or after September 16, 2021, we apply a shared rate limit of 20,000 requests per minute to this endpoint. This rate limit is shared with the /users/delete and /users/alias/new endpoints, as documented in API rate limits . Parameters Parameter Required Data Type Description aliases_to_identify Required Array of aliases to identify object See alias to identify object and user alias object . Aliases to Identify object specification { &quot;external_id&quot; : (required, string) see External User ID below, // external_ids for users that do not exist will return a non-fatal error. // See Server Responses for details. &quot;user_alias&quot; : { &quot;alias_name&quot; : (required, string), &quot;alias_label&quot; : (required, string) } } Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.UserData.html#users_identify_post/2","title":"BrazeEx.Api.UserData.users_identify_post/2","type":"function"},{"doc":"User Track Use this endpoint to record custom events, purchases, and update user profile attributes. Note: Braze processes the data passed via API at face value and customers should only pass deltas (changing data) to minimize unnecessary data point consumption. To read more, refer to Data points . Customers using the API for server-to-server calls may need to whitelist rest.iad-01.braze.com if they’re behind a firewall. Rate limit We apply a base speed limit of 50,000 requests per minute to this endpoint for all customers. Each request to the /users/track endpoint can contain up to 75 events, 75 attribute updates, and 75 purchases. Each component (event, attribute, and purchase arrays), can update up to 75 users each for a max of 225 individual data points. Each update can also belong to the same user for a max of 225 updates to a single user in a request. See our page on API rate limits for details, and reach out to your customer success manager if you need your limit increased. Request parameters Note: For each of the request components listed in the following table, one of external_id , user_alias , or braze_id is required. Parameter Required Data Type Description attributes Optional Array of attributes objects See user attributes object events Optional Array of event objects See events object purchases Optional Array of purchase objects See purchases object Keep the following nuances in mind when using the /users/track endpoint: When creating alias-only users through this endpoint, you must explicitly set the _update_existing_only flag to false . Updating the subscription status with this endpoint will both update the user specified by their external_id (such as User1) and update the subscription status of any users with the same email as that user (User1). User track responses Upon using any of the aforementioned API requests you should receive one of the following three general responses: Successful message Successful messages will be met with the following response: { &quot;message&quot; : &quot;success&quot;, &quot;attributes_processed&quot; : (optional, integer), if attributes are included in the request, this will return an integer of the number of external_ids with attributes that were queued to be processed, &quot;events_processed&quot; : (optional, integer), if events are included in the request, this will return an integer of the number of events that were queued to be processed, &quot;purchases_processed&quot; : (optional, integer), if purchases are included in the request, this will return an integer of the number of purchases that were queued to be processed, } Successful message with non-fatal errors If your message is successful but has non-fatal errors such as one invalid event object out of a long list of events, then you will receive the following response: { &quot;message&quot; : &quot;success&quot;, &quot;errors&quot; : [ { } ] } Message with fatal errors In the case of a success, any data that was not affected by an error in the errors array will still be processed. If your message has a fatal error you will receive the following response: { &quot;message&quot; : , &quot;errors&quot; : [ { } ] } Fatal error response codes The following status codes and associated error messages will be returned if your request encounters a fatal error. Any of these error codes indicate that no data will be processed. Error Code Reason / Cause 400 Bad Request Bad Syntax. 401 Unauthorized Unknown or missing REST API Key. 404 Not Found Unknown REST API Key (if provided). 429 Rate Limited Over rate limit. 5XX Internal server error, you should retry with exponential backoff. If you receive the error “provided external_id is blacklisted and disallowed”, your request may have included a “dummy user”. For more information, refer to Spam blocking . Importing legacy user data You may submit data through the Braze API for a user who has not yet used your mobile app in order to generate a user profile. If the user subsequently uses the application all information following their identification via the SDK will be merged with the existing user profile you created via the API call. Any user behavior that is recorded anonymously by the SDK prior to identification will be lost upon merging with the existing API-generated user profile. The segmentation tool will include these users regardless of whether they have engaged with the app. If you want to exclude users uploaded via the User API who have not yet engaged with the app, simply add the filter: Session Count &gt; 0 . Making bulk updates If you have a use case where you need to make batch updates to the users/track endpoint, we recommend adding the bulk update header so that Braze can properly identify, observe, and route your request. Refer to the following sample request with the X-Braze-Bulk header: curl --location --request POST 'https://rest.iad-01.braze.com/users/track' --header 'Content-Type: application/json' --header 'X-Braze-Bulk: true' --header 'Authorization: Bearer YOUR-API-KEY-HERE' --data-raw '{ &quot;attributes&quot;: [ ], &quot;events&quot;: [ ], &quot;purchases&quot;: [ ] }' Warning: When the X-Braze-Bulk header is present with any value, Braze will consider the request a bulk request. Set the value to true . Currently, setting the value to false does not disable the header—it will still be treated as if it were true. Use cases Consider the following use cases where you may use the bulk update header: A daily job where multiple users’ custom attributes are updated via the /users/track endpoint. An ad-hoc user data backfill script which updates user information via the /users/track endpoint. Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.UserData.html#users_track_post/2","title":"BrazeEx.Api.UserData.users_track_post/2","type":"function"},{"doc":"API calls for all endpoints tagged UserDataExternalIDMigration .","ref":"BrazeEx.Api.UserDataExternalIDMigration.html","title":"BrazeEx.Api.UserDataExternalIDMigration","type":"module"},{"doc":"External ID Remove Note: For security purposes, this feature is disabled by default. To enable this feature, reach out to your customer success manager. Use this endpoint to remove your users’ old deprecated external IDs. This endpoint completely removes the deprecated ID and cannot be undone. You can send up to 50 external IDs per request. You will need to create a new API key with permissions for this endpoint. Rate limit We apply a rate limit of 1,000 requests per minute to this endpoint, as documented in API rate limits . Request parameters Parameter Required Data Type Description external_ids Required Array of strings External identifiers for the users to remove Important: Only deprecated IDs can be removed; attempting to remove a primary external ID will result in an error. Response The response will confirm all successful removals, as well as unsuccessful removals with the associated errors. Error messages in the removal_errors field will reference the index in the array of the original request. { &quot;message&quot; : (string) status message, &quot;removed_ids&quot; : (array of successful Remove Operations), &quot;removal_errors&quot;: (array of any ) } The message field will return success for any valid request. More specific errors are captured in the removal_errors array. The message field returns an error in the case of: Invalid API key Empty external_ids array external_ids array with more than 50 items Rate limit hit (&gt;1,000 requests/minute) Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.UserDataExternalIDMigration.html#users_external_ids_remove_post/2","title":"BrazeEx.Api.UserDataExternalIDMigration.users_external_ids_remove_post/2","type":"function"},{"doc":"External ID Rename Note: For security purposes, this feature is disabled by default. To enable this feature, reach out to your customer success manager. Use this endpoint to rename your users’ external IDs. This endpoint sets a new (primary)  external_id  for the user and deprecates their existing  external_id . This means that the user can be identified by either  external_id  until the deprecated one is removed. Having multiple external IDs allows for a migration period so that older versions of your apps that use the previous external ID naming schema don’t break. Note: You can send up to 50 external IDs per request. You will need to create a new API key with permissions for this endpoint. Rate limit We apply a rate limit of 1,000 requests per minute to this endpoint, as documented in API rate limits . Request parameters Parameter Required Data Type Description external_id_renames Required Array of external ID rename objects View request example and the following limitations for structure of external ID rename object The current_external_id must be the user’s primary ID, and cannot be a deprecated ID The new_external_id must not already be in use as either a primary ID or a deprecated ID The current_external_id and new_external_id cannot be the same Response The response will confirm all successful renames, as well as unsuccessful renames with any associated errors. Error messages in the rename_errors field will reference the index of the object in the array of the original request. { &quot;message&quot; : (string) status message, &quot;external_ids&quot; : (array of successful Rename Operations), &quot;rename_errors&quot;: (array of any ) } The message field will return success for any valid request. More specific errors are captured in the rename_errors array. The message field returns an error in the case of: Invalid API key Empty external_id_renames array external_id_renames array with more than 50 objects Rate limit hit (&gt;1,000 requests/minute) Frequently Asked Questions Does this impact MAU? No, since the number of users will stay the same, they’ll just have a new external_id . Does user behavior change historically? No, since the user is still the same user, and all their historical behavior is still connected to them. Can it be run on dev/staging app groups? Yes. In fact, we highly recommend running a test migration on a staging or development app group, and ensuring everything has gone smoothly before executing on production data. Does this consume data points? This feature does not cost data points. What is the recommended deprecation period? We have no hard limit on how long you can keep deprecated external IDs around, but we highly recommend removing them once there is no longer a need to reference users by the deprecated ID. Parameters connection (BrazeEx.Connection): Connection to server opts (keyword): Optional parameters :content_type (String.t): :authorization (String.t): :body (String.t): Returns {:ok, nil} on success {:error, Tesla.Env.t} on failure","ref":"BrazeEx.Api.UserDataExternalIDMigration.html#users_external_ids_rename_post/2","title":"BrazeEx.Api.UserDataExternalIDMigration.users_external_ids_rename_post/2","type":"function"},{"doc":"Handle Tesla connections for BrazeEx. Additional middleware can be set in the compile-time or runtime configuration: config :tesla , BrazeEx.Connection , base_url : &quot;https://rest.iad-01.braze.com&quot; , adapter : Tesla.Adapter.Hackney The default base URL can also be set as: config :braze_ex , :base_url , &quot;https://rest.iad-01.braze.com&quot;","ref":"BrazeEx.Connection.html","title":"BrazeEx.Connection","type":"module"},{"doc":"Returns the default adapter for this API.","ref":"BrazeEx.Connection.html#adapter/0","title":"BrazeEx.Connection.adapter/0","type":"function"},{"doc":"Returns fully configured middleware for passing to Tesla.client/2.","ref":"BrazeEx.Connection.html#middleware/1","title":"BrazeEx.Connection.middleware/1","type":"function"},{"doc":"Configure a client with no authentication. Returns Tesla.Env.client","ref":"BrazeEx.Connection.html#new/0","title":"BrazeEx.Connection.new/0","type":"function"},{"doc":"Configure a client that may have authentication. Parameters options : a keyword list of OpenAPIPetstore.Connection.options. Returns Tesla.Env.client","ref":"BrazeEx.Connection.html#new/1","title":"BrazeEx.Connection.new/1","type":"function"},{"doc":"Forward requests to Tesla.","ref":"BrazeEx.Connection.html#request/2","title":"BrazeEx.Connection.request/2","type":"function"},{"doc":"The list of options that can be passed to new/1. base_url : Overrides the base URL on a per-client basis. user_agent : Overrides the User-Agent header.","ref":"BrazeEx.Connection.html#t:options/0","title":"BrazeEx.Connection.options/0","type":"type"},{"doc":"Helper functions for deserializing responses into models","ref":"BrazeEx.Deserializer.html","title":"BrazeEx.Deserializer","type":"module"},{"doc":"Update the provided model with a deserialization of a nested value","ref":"BrazeEx.Deserializer.html#deserialize/5","title":"BrazeEx.Deserializer.deserialize/5","type":"function"},{"doc":"Helper functions for building Tesla requests","ref":"BrazeEx.RequestBuilder.html","title":"BrazeEx.RequestBuilder","type":"module"},{"doc":"Add optional parameters to the request. Parameters request (Map) - Collected request options definitions (Map) - Map of parameter name to parameter location. options (KeywordList) - The provided optional parameters Returns Map","ref":"BrazeEx.RequestBuilder.html#add_optional_params/3","title":"BrazeEx.RequestBuilder.add_optional_params/3","type":"function"},{"doc":"Add non-optional parameters to the request. Parameters request (Map) - Collected request options location (atom) - Where to put the parameter key (atom) - The name of the parameter value (any) - The value of the parameter Returns Map","ref":"BrazeEx.RequestBuilder.html#add_param/4","title":"BrazeEx.RequestBuilder.add_param/4","type":"function"},{"doc":"This function ensures that the body parameter is always set. When using Tesla with the httpc adapter (the default adapter), there is a bug where POST, PATCH and PUT requests will fail if the body is empty. Parameters request (Map) - Collected request options Returns Map","ref":"BrazeEx.RequestBuilder.html#ensure_body/1","title":"BrazeEx.RequestBuilder.ensure_body/1","type":"function"},{"doc":"Evaluate the response from a Tesla request. Decode the response for a Tesla request. Parameters result (Tesla.Env.result()): The response from Tesla.request/2. mapping ([{http_status, struct}]): The mapping for status to struct for decoding. Returns {:ok, struct} or {:ok, Tesla.Env.t()} on success {:error, term} on failure","ref":"BrazeEx.RequestBuilder.html#evaluate_response/2","title":"BrazeEx.RequestBuilder.evaluate_response/2","type":"function"},{"doc":"Specify the request method when building a request. Does not override the method if one has already been specified. Parameters request (Map) - Collected request options method (atom) - Request method Returns Map","ref":"BrazeEx.RequestBuilder.html#method/2","title":"BrazeEx.RequestBuilder.method/2","type":"function"},{"doc":"Specify the request URL when building a request. Does not override the url if one has already been specified. Parameters request (Map) - Collected request options url (String) - Request URL Returns Map","ref":"BrazeEx.RequestBuilder.html#url/2","title":"BrazeEx.RequestBuilder.url/2","type":"function"},{"doc":"","ref":"BrazeEx.RequestBuilder.html#t:response_mapping/0","title":"BrazeEx.RequestBuilder.response_mapping/0","type":"type"},{"doc":"","ref":"BrazeEx.RequestBuilder.html#t:status_code/0","title":"BrazeEx.RequestBuilder.status_code/0","type":"type"},{"doc":"Braze HTTP API (generated from Braze Postman Collection)","ref":"readme.html","title":"BrazeEx","type":"extras"},{"doc":"To install the required dependencies and to build the elixir project, run: mix local.hex --force mix do deps.get, compile","ref":"readme.html#building","title":"BrazeEx - Building","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding braze_ex to your list of dependencies in mix.exs : def deps do [ { :braze_ex , &quot;~&gt; 1.0.5&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/braze_ex .","ref":"readme.html#installation","title":"BrazeEx - Installation","type":"extras"},{"doc":"You can override the URL of your server (e.g. if you have a separate development and production server in your configuration files). config :braze_ex , base_url : &quot;https://rest.iad-01.braze.com&quot; Multiple clients for the same API with different URLs can be created passing different base_url s when calling BrazeEx.Connection.new/1 : client = BrazeEx.Connection . new ( base_url : &quot;https://rest.iad-01.braze.com&quot; )","ref":"readme.html#configuration","title":"BrazeEx - Configuration","type":"extras"},{"doc":"Braze provides a high-performance REST API to allow you to track users, send messages, export data, and more. This reference article covers what a REST API is, the terminology, a brief overview of API keys, and API limits. A REST API is a way to programmatically transfer information over the web using a predefined schema. Braze has created many different endpoints which perform various actions and/or return various data. Braze manages a number of different instances for our dashboard and REST Endpoints. When your account is provisioned you will log in to one of the following URLs. Use the correct REST endpoint based on which instance you are provisioned to. If you are unsure, open a support ticket or use the following table to match the URL of the dashboard you use to the correct REST Endpoint. Customers using Braze’s EU database should use the https://rest.fra-01.braze.eu/ endpoint. This endpoint will be used when configuring the Braze iOS , Android , and Web SDKs.","ref":"api_description.html","title":"Braze API overview","type":"extras"},{"doc":"Instance Dashboard URL REST Endpoint US-01 https://dashboard.braze.com or &lt;br&gt; https://dashboard-01.braze.com https://rest.iad-01.braze.com US-02 https://dashboard-02.braze.com https://rest.iad-02.braze.com US-03 https://dashboard-03.braze.com https://rest.iad-03.braze.com US-04 https://dashboard-04.braze.com https://rest.iad-04.braze.com US-05 https://dashboard-05.braze.com https://rest.iad-05.braze.com US-06 https://dashboard-06.braze.com https://rest.iad-06.braze.com US-08 https://dashboard-08.braze.com https://rest.iad-08.braze.com EU-01 https://dashboard-01.braze.eu https://rest.fra-01.braze.eu EU-02 https://dashboard-02.braze.eu https://rest.fra-02.braze.eu Using Braze's Postman collection If you have a Postman account (you can download macOS, Windows, and Linux versions from the Postman website ), you can open our Postman documentation in your own Postman app by clicking the orange Run in Postman button. You can then create an environment , or use our Braze REST API environment as a template, and edit the available POST and GET requests to suit your own needs.","ref":"api_description.html#braze-instances","title":"Braze API overview - Braze Instances","type":"extras"},{"doc":"The Braze Postman Collection uses a templating variable, {{instance_url}} , to substitute the REST API URL of your Braze instance into the pre-built requests, and the {{api_key}} variable for your API Key. Rather than having to manually edit all requests in the Collection, you can set up this variable in your Postman environment. You can either select our templated environment (Braze REST API Environment Template) from the dropdown and replace the variable values with your own, or you can set up your own environment. To set up your own environment, perform the following steps: From the Workspaces tab, select Environments . Click the + plus button to create a new environment. Give this environment a name (e.g., “Braze API Requests”) and add keys for instance_url and api_key with values corresponding to your Braze instance and Braze REST API Key . Click Save .","ref":"api_description.html#setting-up-your-postman-environment","title":"Braze API overview - Setting up your Postman environment","type":"extras"},{"doc":"Once you have configured your environment. You can use any of the pre-built requests in the collection as a template for building new API requests. To start using one of the pre-built requests, click on it within the Collections menu of Postman. This will open the request as a new tab in the main window of the Postman app. In general, there are two types of requests that Braze’s API endpoints accept - GET and POST . Depending on which HTTP method the endpoint uses, you’ll need to edit the pre-built request differently. Edit a POST request When editing a POST request, open the request and navigate to the Body section in the request editor. For readability, select the raw radio button to format the JSON request body. Edit a GET request When editing a GET request, edit the parameters passed in the request URL. To do so, select the Params tab and edit the key-value pairs in the fields that appear.","ref":"api_description.html#using-the-pre-built-requests-from-the-collection","title":"Braze API overview - Using the pre-built requests from the collection","type":"extras"},{"doc":"Once your API request is ready, click Send . The request sends and the response data populates in a section underneath the request editor. From here, you can view the raw data returned from Braze’s API, see the HTTP response code, see how long the request took to process, and view header information. The following documentation can be found on the Braze documentation site: Object &amp; filter specifications API key overview API identifier types Errors &amp; responses Parameters Data retention API network connectivity issues Rate limits API campaigns","ref":"api_description.html#send-your-request","title":"Braze API overview - Send your request","type":"extras"}]